import java.util.Properties;

import javax.sql.DataSource;

import org.hibernate.SessionFactory;
import org.springframework.orm.hibernate3.HibernateTransactionManager;
import org.springframework.orm.hibernate3.LocalSessionFactoryBean;

import com.lcare.dao.hibernate.BaseDAOHibernate;
import com.lcare.dao.hibernate.LookupDAOHibernate;
import com.lcare.dao.hibernate.MessageQueueDAOHibernate;
import com.lcare.dao.hibernate.RoleDAOHibernate;
import com.lcare.dao.hibernate.UserDAOHibernate;

import bran.spring.jacn.AbstractJacnConfigFile;

public class Jacn_hibernate extends AbstractJacnConfigFile {

	static LocalSessionFactoryBean sessionFactory;
	static HibernateTransactionManager transactionManager;
	static BaseDAOHibernate dao;
	static LookupDAOHibernate lookupDAO;
	static UserDAOHibernate userDAO;
	static RoleDAOHibernate roleDAO;
	static MessageQueueDAOHibernate messageQueueDao;
	static BaseDAOHibernate logDao;

	public void wire() throws Exception {
		// type-unsafe way
		//sessionFactory.setDataSource((DataSource) refBean("dataSource"));
		// type-safe way of refering
		sessionFactory.setDataSource(Jacn_resources.dataSource);
		
		sessionFactory.setMappingResources(
				new String[] {
					"com/lcare/model/Role.hbm.xml",
				    "com/lcare/model/User.hbm.xml",
		            "com/lcare/model/UserCookie.hbm.xml",
		            "com/lcare/model/MessageQueue.hbm.xml",
		            "com/lcare/model/Log.hbm.xml"
				}
		);
		
		Properties p = new Properties();
		p.put("hibernate.dialect", "${hibernate.dialect}");
		p.put("hibernate.jdbc.batch_size", "20");
		p.put("hibernate.default_schema", "apple");
		p.put("hibernate.default_catalog", "applogic");
		sessionFactory.setHibernateProperties(p);
		
		transactionManager.setSessionFactory((SessionFactory) sessionFactory.getObject());
		
		dao1.setSessionFactory((SessionFactory) sessionFactory); // shortcut way of ref factorybean
		lookupDAO.setSessionFactory((SessionFactory) sessionFactory);
		userDAO.setSessionFactory((SessionFactory) sessionFactory);
		roleDAO.setSessionFactory((SessionFactory) sessionFactory);
		messageQueueDao.setSessionFactory((SessionFactory) sessionFactory);
		logDao.setSessionFactory((SessionFactory) sessionFactory);

	}
}
