import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.core.io.Resource;
import org.springframework.jdbc.datasource.DriverManagerDataSource;

import bran.spring.jacn.AbstractJacnConfigFile;
/**
 * 
 * @author bran
 *
 */
public class Jacn_resources extends AbstractJacnConfigFile {

	static PropertyPlaceholderConfigurer propertyConfigurer;
	static DriverManagerDataSource dataSource;
	
	public void wire() throws Exception {
		// the placeholder does not have a Java-friendly API, so I use the magic cast here. 
		propertyConfigurer.setLocations((Resource[]) new Object[]{
						"classpath:mail.properties",
						"classpath:database.properties"
						});
		
		dataSource.setDriverClassName("${hibernate.connection.driver_class}");
		dataSource.setUrl("${hibernate.connection.url}");
		dataSource.setUsername("${hibernate.connection.username}");
		dataSource.setPassword("${hibernate.connection.password}");	
	}
}
