/*
 * $Log$
 * Revision 1.2  2005/08/08 14:44:38  branaway
 * cosmetic
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 * Revision 1.1  2005/08/04 08:59:53  bran
 * jacnize more configu files. now only the service config is still in XML
 *
 */
import java.util.ArrayList;
import java.util.List;

import org.springframework.cache.ehcache.EhCacheFactoryBean;
import org.springframework.cache.ehcache.EhCacheManagerFactoryBean;

import net.sf.acegisecurity.context.HttpSessionContextIntegrationFilter;
import net.sf.acegisecurity.context.security.SecureContextImpl;
import net.sf.acegisecurity.intercept.web.FilterInvocationDefinitionSource;
import net.sf.acegisecurity.intercept.web.FilterSecurityInterceptor;
import net.sf.acegisecurity.intercept.web.SecurityEnforcementFilter;
import net.sf.acegisecurity.providers.ProviderManager;
import net.sf.acegisecurity.providers.anonymous.AnonymousAuthenticationProvider;
import net.sf.acegisecurity.providers.anonymous.AnonymousProcessingFilter;
import net.sf.acegisecurity.providers.dao.DaoAuthenticationProvider;
import net.sf.acegisecurity.providers.dao.cache.EhCacheBasedUserCache;
import net.sf.acegisecurity.providers.dao.event.LoggerListener;
import net.sf.acegisecurity.providers.dao.jdbc.JdbcDaoImpl;
import net.sf.acegisecurity.providers.dao.memory.UserAttribute;
import net.sf.acegisecurity.ui.webapp.AuthenticationProcessingFilter;
import net.sf.acegisecurity.ui.webapp.AuthenticationProcessingFilterEntryPoint;
import net.sf.acegisecurity.util.FilterChainProxy;
import net.sf.acegisecurity.vote.AffirmativeBased;
import net.sf.acegisecurity.vote.RoleVoter;
import net.sf.acegisecurity.wrapper.ContextHolderAwareRequestFilter;
import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheManager;
import bran.spring.jacn.AbstractJacnConfigFile;
/**
 * 
 * @author bran
 *
 */
public class Jacn_security extends AbstractJacnConfigFile {
	static FilterChainProxy filterChainProxy;
	static FilterSecurityInterceptor filterInvocationInterceptor;
	static ProviderManager authenticationManager;
	static LoggerListener loggerListener;
	static DaoAuthenticationProvider daoAuthenticationProvider;
	static JdbcDaoImpl jdbcAuthenticationDao;
	static EhCacheBasedUserCache userCache;
	static AnonymousAuthenticationProvider anonymousAuthenticationProvider;
	static RoleVoter roleVoter;
	static AffirmativeBased accessDecisionManager;
	static HttpSessionContextIntegrationFilter httpSessionContextIntegrationFilter;
	static AuthenticationProcessingFilter authenticationProcessingFilter;
	static AnonymousProcessingFilter anonymousProcessingFilter;
	static SecurityEnforcementFilter securityEnforcementFilter;
	static ContextHolderAwareRequestFilter remoteUserFilter;
	static AuthenticationProcessingFilterEntryPoint authenticationProcessingFilterEntryPoint;
	
	public void wire() throws Exception {
		Object filter = // the "\n" of of each line is mandatory
			"CONVERT_URL_TO_LOWERCASE_BEFORE_COMPARISON\n" + 
			"PATTERN_TYPE_APACHE_ANT\n" +
			"/j_security_check*=httpSessionContextIntegrationFilter,authenticationProcessingFilter\n" + 
			"/**/*.html*=httpSessionContextIntegrationFilter,remoteUserFilter,anonymousProcessingFilter,securityEnforcementFilter\n" +
			"/**/*.jsp*=httpSessionContextIntegrationFilter,remoteUserFilter,securityEnforcementFilter";
		filterChainProxy.setFilterInvocationDefinitionSource(
				(FilterInvocationDefinitionSource) filter  // magic converting - bean editor will do the job
		);
		
		filterInvocationInterceptor.setAuthenticationManager(authenticationManager);
		filterInvocationInterceptor.setAccessDecisionManager(accessDecisionManager);
		Object ods = 
			"CONVERT_URL_TO_LOWERCASE_BEFORE_COMPARISON\r\n" + 
			"PATTERN_TYPE_APACHE_ANT\r\n" + 
			"/signup.html=ROLE_ANONYMOUS,admin,tomcat\r\n" + 
			"/passwordhint.html*=ROLE_ANONYMOUS,admin,tomcat\r\n" + 
			"/**/*.html*=admin,tomcat\r\n" + 
			"/clickstreams.jsp=admin";
		//		 magic converting - bean editor will do the job
		filterInvocationInterceptor.setObjectDefinitionSource((FilterInvocationDefinitionSource) ods);
		
		//
		List providers = new ArrayList();
		providers.add(daoAuthenticationProvider);
		providers.add(anonymousAuthenticationProvider);
		// we might try magic cast again
		//	(List)new Object[]{daoAuthenticationProvider, anonymousAuthenticationProvider});
		// we could try Arrays.asList(new Object[]{...});
		// Object l = new Object[] {daoAuthenticationProvider, anonymousAuthenticationProvider};
		authenticationManager.setProviders(providers);
		
		//
		daoAuthenticationProvider.setAuthenticationDao(jdbcAuthenticationDao);
		daoAuthenticationProvider.setUserCache(userCache);
		
		// 
		//ref bean in another jacn file
		jdbcAuthenticationDao.setDataSource(Jacn_resources.dataSource);
		jdbcAuthenticationDao.setUsersByUsernameQuery("SELECT username,password,enabled FROM app_user WHERE username = ?");
		jdbcAuthenticationDao.setAuthoritiesByUsernameQuery("SELECT username,role_name FROM user_role WHERE username = ?");
		
		//
		EhCacheFactoryBean cacheFactory = new EhCacheFactoryBean(); // must init or it won't compile
		cacheFactory.setCacheManager((CacheManager) new EhCacheManagerFactoryBean().getObject());
		cacheFactory.setCacheName("userCache");
		userCache.setCache((Cache) cacheFactory.getObject()); // this is how to use factorybean
		
		//
		anonymousAuthenticationProvider.setKey("anonymous");
		//
		roleVoter.setRolePrefix("");
		//
		accessDecisionManager.setAllowIfAllAbstainDecisions(false);
		List voters = new ArrayList(); // don't reuse previously defined locals 
		voters.add(roleVoter);
		accessDecisionManager.setDecisionVoters(voters);
		//
		// must use .class symtax. Any other way of obtaining Class object is not supported
		httpSessionContextIntegrationFilter.setContext(SecureContextImpl.class);
		//
		authenticationProcessingFilter.setAuthenticationManager(authenticationManager);
		authenticationProcessingFilter.setAuthenticationFailureUrl("/login.jsp?error=true");
		authenticationProcessingFilter.setDefaultTargetUrl("/");
		authenticationProcessingFilter.setFilterProcessesUrl("/j_security_check");
		
		//
		anonymousProcessingFilter.setKey("anonymous");
		Object ua = "anonymous,ROLE_ANONYMOUS";
		//		 magic converting - bean editor will do the job
		anonymousProcessingFilter.setUserAttribute((UserAttribute)ua);
		
		//
		securityEnforcementFilter.setFilterSecurityInterceptor(filterInvocationInterceptor);
		securityEnforcementFilter.setAuthenticationEntryPoint(authenticationProcessingFilterEntryPoint);
		
		//
		authenticationProcessingFilterEntryPoint.setLoginFormUrl("/login.jsp");
		authenticationProcessingFilterEntryPoint.setForceHttps(false);
	}
}
