import java.util.Properties;

import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.runtime.resource.loader.ClasspathResourceLoader;
import org.springframework.aop.support.RegexpMethodPointcutAdvisor;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSenderImpl;
import org.springframework.orm.hibernate3.HibernateTransactionManager;
import org.springframework.transaction.interceptor.TransactionProxyFactoryBean;
import org.springframework.ui.velocity.VelocityEngineFactoryBean;

import applogic.sms.QueueDispatcher;
import applogic.sms.SmsPoster;
import applogic.sms.SmsUtils;
import bran.spring.jacn.AbstractJacnConfigFile;

import com.lcare.service.MailEngine;
import com.lcare.service.UserSecurityAdvice;
import com.lcare.service.impl.BaseManager;
import com.lcare.service.impl.LookupManagerImpl;
import com.lcare.service.impl.RoleManagerImpl;
import com.lcare.service.impl.UserManagerImpl;
import com.lcare.webapp.SmsQueueManager;
import com.lcare.webapp.SmsQueueManagerImpl;

public class Jacn_service_simplified extends AbstractJacnConfigFile {
	static LookupManagerImpl lookupManager;
	static BaseManager manager;
	static UserManagerImpl userManager;
	static RoleManagerImpl roleManager;
	static SmsQueueManagerImpl smsQueueManager;
	static RegexpMethodPointcutAdvisor userSecurityInterceptor;
	static UserSecurityAdvice userSecurityAdvice;
	static MailEngine mailEngine;
	static JavaMailSenderImpl mailSender;
	static VelocityEngineFactoryBean velocityEngineFactory;
		SimpleMailMessage mailMessage;
	static SmsPoster smsPoster;
	static QueueDispatcher queueDispatcher;
	static SmsUtils smsUtils;
	
	public void wire() throws Exception {
		lookupManager.setLookupDAO(Jacn_hibernate.lookupDAO);
		
		Properties p = new Properties();
		p.put("save*", "PROPAGATION_REQUIRED");
		p.put("remove*", "PROPAGATION_REQUIRED");
		p.put("*", "PROPAGATION_REQUIRED,readOnly");
	
		HibernateTransactionManager transactionManager = Jacn_hibernate.transactionManager;

		manager.setDAO(Jacn_hibernate.dao);
		enableTx(manager, transactionManager, p);
		
		userManager.setUserDAO(Jacn_hibernate.userDAO);
		Properties pu = new Properties();
		pu.put("save*", "PROPAGATION_REQUIRED,-UserExistsException");
		pu.put("remove*", "PROPAGATION_REQUIRED");
		pu.put("*LoginCookie", "PROPAGATION_REQUIRED");
		pu.put("*", "PROPAGATION_REQUIRED,readOnly");
		enableTx(userManager, transactionManager, pu, new Object[] {userSecurityInterceptor}, null);

		userSecurityInterceptor.setAdvice(userSecurityAdvice);
		userSecurityInterceptor.setPatterns(new String[] {".*saveUser", ".*removeUser"});
		
		roleManager.setRoleDAO(Jacn_hibernate.roleDAO);
		enableTx(roleManager, transactionManager, p);
		
		mailEngine.setMailSender(mailSender);
		mailEngine.setVelocityEngine((VelocityEngine) velocityEngineFactory.getObject());
		
		mailSender.setHost("${mail.host}");
		mailSender.setUsername("${mail.username}");
		mailSender.setPassword("${mail.password}");
		
		Properties vp = new Properties();
		vp.put("resource.loader", "class");
		vp.put("class.resource.loader.class", ClasspathResourceLoader.class.getName());
		vp.put("velocimacro.library", "");
		velocityEngineFactory.setVelocityProperties(vp);
		
		mailMessage.setFrom("${mail.default.from}");
		
		smsQueueManager.setMqDao(Jacn_hibernate.messageQueueDao);
		smsQueueManager.setSmsPoster(smsPoster);
		smsQueueManager.setLogDao(Jacn_hibernate.logDao);
		Properties sp = new Properties();
		sp.put("queue*", "PROPAGATION_REQUIRED");
		sp.put("send*", "PROPAGATION_REQUIRED");
		sp.put("save*", "PROPAGATION_REQUIRED");
		sp.put("log*", "PROPAGATION_REQUIRED");
		sp.put("*", "PROPAGATION_REQUIRED,readOnly");
		enableTx(smsQueueManager, transactionManager, sp);
		
		smsPoster.setEndPointHostNameForUpwardMessage("loci.ccniit.com");
		smsPoster.setEndPointPortForUpwardMessage(8000);
		smsPoster.setEndPointPathForUpwardMessage("/demo1/SMS/Gate.aspx");
		smsPoster.setEndPointHostNameForDownwardMessage("loci.ccniit.com");
		smsPoster.setEndPointPortForDownwardMessage(8000);
		smsPoster.setEndPointPathForDownwardMessage("/demo1/sendmessage");
		smsPoster.setAllsmartHost("loci.ccniit.com");
		smsPoster.setAllsmartPort(8000);
		smsPoster.setAllsmartReqPath("/demo1/reportone");
		
		queueDispatcher.setQm(smsQueueManager); 
		
		queueDispatcher.setPollIntervalSecs(10);
		
		smsUtils.setSmsSize(400);
	}

}
