package bran.spring.jacn;

import java.util.Properties;

import org.springframework.transaction.PlatformTransactionManager;

public abstract class AbstractJacnConfigFile implements IJacnConfigFile {
	/**
	 * a marker method to mark a <ref bean> to an external bean ref, which might in a XML
	 * so that we won't be able to ref it directly from Jacn config file
	 * @param name the name of the bean defined in other context files, possibly an XML definition
	 * file. 
	 * @return
	 */
	protected Object refBean(String name) {
		return null;
	}
	
	// see javadoc in the interface
	public void destroy() throws Exception {
	}

	// see javadoc in the interface
	public void init() throws Exception {
	}

//	public void invoke() throws Exception {
//	}
	
	/**
	 * apply transaction control to the target object
	 * 
	 * @param target
	 * @param txMan
	 * @param txAttributeProps
	 * @param interfaces  the interfaces that are to be made transactional. can be null
	 * @param preInterceptors, can be null
	 * @param postInterceptors, can be null
	 */
	public void enableTx(
			Object target, 
			PlatformTransactionManager txMan, 
			Properties txAttributeProps, 
			Class[] interfaces,
			Object[] preInterceptors,
			Object[] postInterceptors
			) {	}
	
/*	public void enableTx(
			Object target, 
			PlatformTransactionManager txMan, 
			Properties txAttributeProps, 
			Class[] interfaces,
			Object[] preInterceptors
	) {
	}


	public void enableTx(
			Object target, 
			PlatformTransactionManager txMan, 
			Properties txAttributeProps, 
			Class[] interfaces
	) {	}

	public void enableTx(
			Object target, 
			PlatformTransactionManager txMan, 
			Properties txAttributeProps 
	) {	}
*/
	/**
	 * indicate the object must be lazy-inited
	 */
	public void lazyInit(Object target) {}

	/**
	 * set the autoWire attribute of the bean to by type
	 * @param foo
	 */
	final protected void autoWireByType(Object foo) {	}

	/**
	 * set the autoWire attribute of the bean to by name
	 * @param foo
	 */
	final protected void autoWireByName(Object foo) {	}
	
	final protected void loadPlaceholderProperties(String[] paths) {};
	
	/**
	 * set the life cycle of the beans to associate with http Session
	 * @param beans
	 */
	final protected void setWebScopeSession(Object[] beans) {};
	
	/**
	 * set the life cycle of the beans to associate with http request
	 * @param beans
	 */
	final protected void setWebScopeRequest(Object[] beans) {};
	
	/**
	 * bind an El expression to the faces context
	 * @param elExp can be with or without "#{" and "}", pref without
	 */
	final protected Object bindValue(String elExp) {return null;}
	
	/**
	 * apply interceptors to the target by method patterns
	 * 
	 * @param target
	 * @param interfaces
	 * @param patterns the simple DOS pattern: *xxx or xxx*
	 * @param advices interceptors or advices
	 */
	final protected void weaveAspects(Object target, Object[] interfaces, String[] patterns, Object[] advices) {};
}
