package bran.spring.jacn;

import org.jdom.Attribute;
import org.objectweb.asm.tree.FieldNode;


public class FieldElementObj extends XmlElementObject{
	String webScope; // value of WebScope.nnn
	
	FieldNode o;
//	Element e;
	boolean isSynthesized = false;
	private boolean isSingleton;
	FieldElementObj(FieldNode f) {
		super(f);
		this.o = f;
		e = ConvertUtil.newBeanDef(ConvertUtil.desc2reg(f.desc), f.name);
		isField = true;
	}

	public FieldElementObj(String classDesc, String id) {
		this(classDesc, id, false);
	}
	FieldElementObj(String classDesc, String id, boolean isSynthesized) {
		super(id);
		this.name = id;
		super.typeDesc = classDesc;
		String className = ConvertUtil.desc2reg(classDesc);
		e = ConvertUtil.newBeanDef(className, id);
		isField = true;
		this.isSynthesized = isSynthesized;
	}

	public void setSingleton(boolean b) {
		e.getAttributes().add(new Attribute("singleton", String.valueOf(b)));
//		this.isSingleton = b;
	}
	
	public boolean isSingleton() {
		Attribute a = e.getAttribute("singleton");
		if (a == null) {
			return true;
		}
		else {
			return Boolean.valueOf(a.getValue()).booleanValue();
		}
	}

	/**
	 * set the init method of the bean
	 * 
	 * @param methodName
	 */
	public void setInitMethod(String methodName) {
		e.getAttributes().add(new Attribute("init-method", methodName));
	}
	
	/**
	 * set the destory method of the bean
	 * 
	 * @param methodName
	 */
	public void setDestroyMethod(String methodName) {
		e.getAttributes().add(new Attribute("destroy-method", methodName));
	}
	
	
	public void autoWireByName() {
		e.getAttributes().add(new Attribute("autowire", "byName"));
	}
	public void autoWireByType() {
		e.getAttributes().add(new Attribute("autowire", "byType"));
	}

	public void lazyInit() {
		e.getAttributes().add(new Attribute("lazy-init", "true"));
	}

	public void assignedValue(XmlElementObject xo) {
		ConvertUtil.merge2Left(e, xo.e);
		e.setAttribute("class", getClassName());
	}

	public String getName() {
		return name;
	}
}
