/**
 * $Log$
 * Revision 1.5  2006/07/02 04:53:29  branaway
 * support init() and destroy() - the init-method and destroy-method in bean def
 *
 * Revision 1.4  2005/08/10 12:09:20  branaway
 * deprecated invoke interface in the config interface. now arbitrary method invoking on beans are supported in the wire method
 *
 * Revision 1.3  2005/08/08 17:09:07  branaway
 * added support for adding post processing functional calls.
 * removed web dir since the web is now in another module called htdocs
 *
 * Revision 1.2  2005/08/03 12:42:48  branaway
 * added support for web application context integration: JacnWebApplicationContext
 * 
 */

package bran.spring.jacn;

/**
 * All Jacn configuration classes need to implment this. Additionally only a subset of Java syntax 
 * is supported. 
 * 
 * TODO: more doc
 * 
 * @author bran
 *
 */
public interface IJacnConfigFile {
	/**
	 * make calls to the setters and other special methods to demo how beans are dependent on each other
	 * @throws Exception
	 */
	void wire() throws Exception;
	/**
	 * simply make a call to the init-method of beans to indicate the init-method of beans
	 * not implmented yet. The old impl configured a method-invocation factory bean created, 
	 * giving similar result. 
	 * 
	 * allows only bean.call() method 
	 * 
	 * @throws Exception
	 */
	void init() throws Exception;  

	/**
	 * simply make a call to the destroy-method of beans to indicate the destroy-method of beans
	 * 
	 * allows only bean.call() method 
	 * 
	 * @throws Exception
	 */
	void destroy() throws Exception;
	
//	/**
//	 * Put all the general (none setter )method invocations on beans here. 
//	 * All the method calls will be mapped to MethodInvokingFactoryBean definitions. 
//	 * this is more generic than the init-method attribute on beans since it can take args
//	 * @throws Exception
//	 * @deprecated now put any call statement in the wire() will work
//	 */
//	void invoke() throws Exception;
}
