/*
 * $Log$
 * Revision 1.33  2006/07/02 04:48:52  branaway
 * factor out interal classes
 *
 * Revision 1.32  2005/10/21 03:03:42  branaway
 * minor enhancement of SpringFaces
 *
 * Revision 1.31  2005/09/28 10:05:15  branaway
 * added support for generic AOP
 *
 * Revision 1.30  2005/09/27 14:58:55  branaway
 * added support for proxying prototype beans
 *
 * Revision 1.29  2005/09/26 16:02:10  branaway
 * added interface for better injection of implicit objects in the faces aware objects. added caching in the variable resolver. moving the implicit injection from jacn app contextto variable resolver.
 *
 * Revision 1.28  2005/09/24 17:58:15  branaway
 * added special method called bindValue for handlinggeneric #{el} expression
 *
 * Revision 1.27  2005/09/21 03:48:59  branaway
 * now the scoping of Jacn beans really work with the introduction o SpringFacesBeanFactory. SetJSf value binding on  bean properties also works.
 *
 * Revision 1.26  2005/09/20 14:56:43  branaway
 * added setWebScopeSession and setWebScopeRequest to the config file, so later on we can use that informaion in jacn unified JSF and Spring
 *
 * Revision 1.25  2005/09/08 14:53:37  branaway
 * fixed issues with .class in jdk5
 *
 * Revision 1.24  2005/09/06 15:03:30  branaway
 * force cglib for enableTx if no interface is specified for the target object
 *
 * Revision 1.23  2005/09/04 11:51:08  branaway
 * fixed the operand to use for external field reference
 *
 * Revision 1.22  2005/09/04 10:23:46  branaway
 * support referencing factorybean instance itself
 *
 * Revision 1.21  2005/08/25 22:49:33  branaway
 * added supported for ctor DI and setter DI mixed in any order
 *
 * Revision 1.20  2005/08/25 09:41:51  branaway
 * support antowire on transactional object
 *
 * Revision 1.19  2005/08/25 07:43:28  branaway
 * better support for ArrayList as regular bean
 *
 * Revision 1.18  2005/08/23 19:29:39  branaway
 * various fixes
 *
 * Revision 1.17  2005/08/23 05:08:02  branaway
 * added loadPlaceholderProperties() API to eliminate the use of PropertyPlaceholderFactoryBean
 *
 * Revision 1.16  2005/08/22 14:44:33  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.15  2005/08/20 15:01:14  branaway
 * made the testEnableTx a real test against the DOM structure.
 * removed jDom from the jacn jar.
 *
 * Revision 1.14  2005/08/20 09:05:24  branaway
 * fixed issues when debug is off
 *
 * Revision 1.13  2005/08/19 19:21:31  branaway
 * added layInit. Added build.xml
 *
 * Revision 1.12  2005/08/10 12:09:20  branaway
 * deprecated invoke interface in the config interface. now arbitrary method invoking on beans are supported in the wire method
 *
 * Revision 1.11  2005/08/10 06:56:37  branaway
 * added support for implicitly using TransactionProxyFactoryBean
 *
 * Revision 1.10  2005/08/08 17:09:07  branaway
 * added support for adding post processing functional calls.
 * removed web dir since the web is now in another module called htdocs
 *
 * Revision 1.9  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 * Revision 1.8  2005/08/04 15:53:47  branaway
 * clean the comment
 *
 */
package bran.spring.jacn;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import org.jdom.Attribute;
import org.jdom.Element;
import org.objectweb.asm.AnnotationVisitor;
import org.objectweb.asm.Label;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.Type;
import org.objectweb.asm.tree.LocalVariableNode;
import org.objectweb.asm.tree.MethodNode;
import org.objectweb.asm.util.ASMifierAbstractVisitor;
import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.config.MethodInvokingFactoryBean;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;

/**
 * A {@link MethodVisitor} that, together with {@link JacnClassVisitor}, constructs the 
 * dependency relationship of Jacn beans and presents the result in DOM document. 
 * 
 * this one is really the wire() method visitor. 
 * 
 * @author bran
 * @version 0.5
 */

public class JacnMethodVisitor extends ASMifierAbstractVisitor
		implements MethodVisitor, Opcodes {

	Element tmpArrayElement;
	Element tmpElement;
	
	int currentLine;
	String methodName;
	int access;

	Type[] argumentTypes;

	int firstLocal;

	/**
	 * [name, XmlElementObject]
	 */
	Map locals;

	List localTypes;
	
	List localVars;

	int lastOpcode = -1;

	HashMap labelNames;
	private JacnClassVisitor springConfig;

	static final int SUNJDK = 0;
	static final int ECLIPSEJDT = 1;
	
	int compilerHint = -1; 

	public JacnMethodVisitor(JacnClassVisitor springConfig, String name, int access, String desc) {
		super("mg");
		this.springConfig = springConfig;
		methodName = name;
		this.access = access;
		this.labelNames = new HashMap();
		this.argumentTypes = Type.getArgumentTypes(desc);
		int nextLocal = ((Opcodes.ACC_STATIC & access) != 0) ? 0 : 1;
		for (int i = 0; i < argumentTypes.length; i++) {
			nextLocal += argumentTypes[i].getSize();
		}
		this.firstLocal = nextLocal;
		this.locals = new HashMap();
		if ((Opcodes.ACC_STATIC & access) == 0) {
			// instance method
			locals.put("this", new ThisVar(null));
		}
		this.localTypes = new ArrayList();
	}


//	MethodNode methodNode;
	//private Frame[] frames;
	
	int insnSequence = 0;

	private boolean isBuildingtArray = false;
	private int numArrayEleTobeInit;
	
	// process <class>.class syntax
	private boolean isProcessingDotClass = false;
	private Label dotClassEndLabel;
	private String currentDotClassFieldName;
	private String currentDotClassName;
	private boolean fullyExitDotClassMess = true;
	private Element valueElementNeedType = null;
	private boolean needDecorating = false;

//	public MethodNode getMethodNode() {
//		return methodNode;
//	}

	public void setMethodNode(MethodNode methodNode){
//		this.methodNode = methodNode;
//		localVars = methodNode.localVariables; // the info is complete if(?) the debug info is embedded
	}

	public AnnotationVisitor visitAnnotationDefault() {
		notValid("visitAnnotationDefault");
		return null;
	}

	public AnnotationVisitor visitParameterAnnotation(final int parameter,
			final String desc, final boolean visible) {
		notValid("visitParameterAnnotation");
		return null;
	}

	public void visitCode() {
		/*text.add("mg.visitCode();\n");*/
	}

	public void visitInsn(final int opcode) {
		if (!isProcessingDotClass) {
			switch (opcode) {
			case IRETURN:
			case LRETURN:
			case FRETURN:
			case DRETURN:
			case ARETURN:
			case RETURN:
				break;
			case NOP:
				break;
			case ACONST_NULL:
				push(new NullObject());
				break;
			case ICONST_M1:
			case ICONST_0:
			case ICONST_1:
			case ICONST_2:
			case ICONST_3:
			case ICONST_4:
			case ICONST_5:
				int constNum = opcode - ICONST_0;
				push(newConstObject(new Integer(constNum)));
				break;
			case LCONST_0:
			case LCONST_1:
				long lconst = opcode - LCONST_0;
				push(newConstObject(new Long(lconst)));
				break;
			case FCONST_0:
			case FCONST_1:
			case FCONST_2:
				float fconst = opcode - FCONST_0;
				push(newConstObject(new Float(fconst)));
				break;
			case DCONST_0:
			case DCONST_1:
				float dconst = opcode - DCONST_0;
				push(newConstObject(new Double(dconst)));
				break;
			case POP:
				pop();
				break;
			case POP2:
				break;
			case DUP:
				push((XmlElementObject) peek().clone());

				break;
			case DUP_X1:
				break;
			case DUP_X2:
				break;
			case DUP2:
				break;
			case DUP2_X1:
				break;
			case DUP2_X2:
				break;
			case SWAP:
				break;
			case MONITORENTER:
				break;
			case MONITOREXIT:
				break;
			case ARRAYLENGTH:
				break;
			case IALOAD:
				break;
			case LALOAD:
				break;
			case FALOAD:
				break;
			case DALOAD:
				break;
			case AALOAD:
				break;
			case BALOAD:
				break;
			case CALOAD:
				break;
			case SALOAD:
				break;
			case IASTORE:
				break;
			case LASTORE:
				break;
			case FASTORE:
				break;
			case DASTORE:
				break;
			case AASTORE:
				XmlElementObject ae  = pop();
				// int index = ((Integer)pop().o).intValue();
				pop(); // index
				pop(); // the array itself
				ArrayObject ao = (ArrayObject) peek();
				ao.addValue(ae);
				if (--numArrayEleTobeInit == 0)
					isBuildingtArray = false;

				// XmlElementObject ae = peek();
				break;
			case BASTORE:
				break;
			case CASTORE:
				break;
			case SASTORE:
				break;
			case IADD:
				break;
			case LADD:
				break;
			case FADD:
				break;
			case DADD:
				break;
			case ISUB:
				break;
			case LSUB:
				break;
			case FSUB:
				break;
			case DSUB:
				break;
			case IMUL:
				break;
			case LMUL:
				break;
			case FMUL:
				break;
			case DMUL:
				break;
			case IDIV:
				break;
			case LDIV:
				break;
			case FDIV:
				break;
			case DDIV:
				break;
			case IREM:
				break;
			case LREM:
				break;
			case FREM:
				break;
			case DREM:
				break;
			case INEG:
				break;
			case LNEG:
				break;
			case FNEG:
				break;
			case DNEG:
				break;
			case ISHL:
				break;
			case LSHL:
				break;
			case ISHR:
				break;
			case LSHR:
				break;
			case IUSHR:
				break;
			case LUSHR:
				break;
			case IAND:
				break;
			case LAND:
				break;
			case IOR:
				break;
			case LOR:
				break;
			case IXOR:
				break;
			case LXOR:
				break;
			case ATHROW:
				break;
			case I2L:
				break;
			case I2F:
				break;
			case I2D:
				break;
			case L2I:
				break;
			case L2F:
				break;
			case L2D:
				break;
			case F2I:
				break;
			case F2L:
				break;
			case F2D:
				break;
			case D2I:
				break;
			case D2L:
				break;
			case D2F:
				break;
			case I2B:
				// TODO detect if previous element in 'text' is a cast,
				// for possible optimisations (e.g. cast(F,I) cast(I,B) =
				// cast(F,B))
				break;
			case I2C: // idem
				break;
			case I2S: // idem
				break;
			case LCMP:
			case FCMPL:
			case FCMPG:
			case DCMPL:
			case DCMPG:
				// TODO detect xCMPy IF_ICMP -> ifCmp(..., ..., label)
				break;
			default:
				throw new RuntimeException("unexpected case");
			}
		}
		this.insnSequence++;
		lastOpcode = opcode;
	}

	private XmlElementObject peek() {
		return (XmlElementObject) operands.peek();
	}

	private XmlElementObject pop() {
		return (XmlElementObject) operands.pop();
	}

	public void visitIntInsn(final int opcode, final int operand) {
		if (opcode == NEWARRAY) {
//			String type;
			switch (operand) {
			case T_BOOLEAN:
				break;
			case T_CHAR:
				break;
			case T_FLOAT:
				break;
			case T_DOUBLE:
				break;
			case T_BYTE:
				break;
			case T_SHORT:
				break;
			case T_INT:
				break;
			case T_LONG:
				break;
			default:
				throw new RuntimeException("unexpected case");
			}
		}
		else {
			operands.push(newConstObject(new Integer(operand)));
		}
		lastOpcode = opcode;
		this.insnSequence++;
	}

	public void visitVarInsn(final int opcode, int varIndex) {
		switch (opcode) {
		case RET:
			if (varIndex < firstLocal) {
			} else {
			}
			break;

		case ILOAD:
			break;
		case LLOAD:
			break;
		case FLOAD:
			break;
		case DLOAD:
			break;
		case ALOAD:
			 
			//LocalVariableNode l = (LocalVariableNode) methodNode.localVariables.get(var);
			operands.push(getLocalVarElement(varIndex));
			break;

		case ISTORE:
			break;
		case LSTORE:
			break;
		case FSTORE:
			break;
		case DSTORE:
			break;
		case ASTORE:
//			LocalVariableNode lv = (LocalVariableNode) localVars.get(varIndex); // todo assuming this method has empty arg list
			String varName = getLocalVarName(varIndex);
			XmlElementObject newe= (XmlElementObject) operands.pop();
			if (!newe.isField()) {
				// change the element type to a local var type
				newe.isLocalVar = true;
				if(varName != null && varName.length()> 0){
					newe.name = varName;
				}
				else {
					newe.name = getTmpVarName(varIndex);
				}
				newe.localVarIndex = varIndex;
				newe.e.removeAttribute("id");
				addAttr(newe.e, "id", this.methodName + "_" + varName);
			}
			locals.put(varName, newe);
			break;
		default:
			throw new RuntimeException("unexpected case");
		}

		lastOpcode = opcode;
		this.insnSequence++;
	}

	private String getTmpVarName(int var) {
		return "__" + var;
	}

	/**
	 * get the XmlVar object
	 * @param var
	 * @return
	 */
	private XmlElementObject getLocalVarElement(int var) {
		String varName = getLocalVarName(var);
		return (XmlElementObject) locals.get(varName);
	}

	public void visitTypeInsn(final int opcode, final String desc) {
		// todo fix the type
		if (isProcessingDotClass) {
			lastOpcode = opcode;
			this.insnSequence++;
			return;
		}
		String type;
		if (desc.charAt(0) == '[') {
			type = ConvertUtil.getDescType(desc); // xxx
		} else {
			type = ConvertUtil.getType(desc);
		}
		
		Class typeClass = null;
		try {
			typeClass = Class.forName(type);
		} catch (ClassNotFoundException e1) {
			notValid(e1.getMessage());
		}
		
		XmlElementObject xe;
		if (opcode == NEW) {
			if (Properties.class.isAssignableFrom(typeClass)) {
				xe = new PropertiesObject(getTmpVarName());
			}
			else if(List.class.isAssignableFrom(typeClass))  {
				xe = new ListObject(getTmpVarName());
				((ListObject)xe).setImplClass(typeClass);
			}
			else if (Set.class.isAssignableFrom(typeClass)) {
				xe = new SetObject(getTmpVarName());
			} // todo add set, list etc
			else if (Map.class.isAssignableFrom(typeClass)) {
				xe = new MapObject(getTmpVarName());
			} // todo add set, list etc
			else {
				xe = new XmlElementObject(type);
				xe.e = newBeanDef(type, getTmpVarName());
				xe.typeDesc = desc;
			}
			push(xe);
		} else if (opcode == ANEWARRAY) {
			isBuildingtArray = true;
			XmlElementObject x = (XmlElementObject) operands.pop();
			ConstObject xc = ((ConstObject)x);
			try {
				this.numArrayEleTobeInit = Integer.parseInt(xc.o.toString());
			} catch (NumberFormatException e) {
				notValid("array must be immediately initialized. " +desc);
			}

			XmlElementObject ao = new ArrayObject(desc, numArrayEleTobeInit);
			ao.typeDesc = desc;
			push(ao);
			
		} else if (opcode == CHECKCAST) {
			if (this.needDecorating  && valueElementNeedType != null) {
				valueElementNeedType.getAttributes().add(new Attribute("type", type));
				needDecorating = false;
			}
			// do thing, leave the operand intact
		} else if (opcode == INSTANCEOF) {
		}
		lastOpcode = opcode;
		this.insnSequence++;
	}

	public void visitFieldInsn(final int opcode, final String owner,
			final String name, final String desc) {
		if (!isProcessingDotClass) {
			switch (opcode) {
			case GETFIELD:
				operands.pop();
				operands.push(getFieldElement(name));
				break;
			case PUTFIELD:
				// this is to create a bean, maybe init with none-default
				// constructor
			{
				XmlElementObject xo = pop();
				pop(); // the owner
				FieldElementObj fe = getFieldElement(name);
				// keep the list ovject for now
				if (false && xo instanceof ListObject) {
					// convert to bean format
					ListObject lo = (ListObject)xo;
					Element e  = ConvertUtil.newBeanDef(lo.getImplClass().getName(), name);
					fe.e = e;
				}
				// todo: may need to deal with other special tpes such as String, Map, Set, properties, etc
				else {
					if (xo instanceof ListObject) {
						fe.setClassName(((ListObject)xo).getImplClass().getName());
					}
					fe.assignedValue(xo);
				}
			}
			break;
			case GETSTATIC:
				if (isDotClass(name)) {
					// ok must be .class synth field
					if (compilerHint == SUNJDK && !fullyExitDotClassMess) {
						fullyExitDotClassMess = true;
					}
					else {
						enterDotClassMess();
						// basically we catch the LDC to get the name of the class
						// and leave the name on the stack after we fully exit the .class mess
						// TODO: this is very Spring specific and not portable
					}
					
					this.currentDotClassFieldName = name;
					// until the end of
				}
				else {
					if (owner.equals(this.springConfig.className)){
						operands.push(getFieldElement(name));
					}
					else {
						// assuming external bean can never be on LHS
						FieldElementObj externalField = new FieldElementObj(desc, name);
//						XmlElementObject externalField = new XmlElementObject(desc);
//						externalField.e = ConvertUtil.newRefBean(name);
						push(externalField);
					}
				}
				break;
			case PUTSTATIC: 
				if (owner.equals(this.springConfig.className)){
					XmlElementObject xo = pop();
					FieldElementObj fe = getFieldElement(name);
					// keep the list ovject for now
					if (false && xo instanceof ListObject) {
						// convert to bean format
						ListObject lo = (ListObject)xo;
						Element e  = ConvertUtil.newBeanDef(lo.getImplClass().getName(), name);
						fe.e = e; // wrong! don't replace todo: 
					}
					// todo: may need to deal with other special tpes such as String, Map, Set, properties, etc
					else {
						if (xo instanceof ListObject) {
							fe.setClassName(((ListObject)xo).getImplClass().getName());
						}
						fe.assignedValue(xo);
					}
				}
				else {
					notValid("PUTstatic on external static field is not supported");
				}
				
				break;
			default:
				throw new RuntimeException("unexpected case");
			}
		}
		lastOpcode = opcode;
		this.insnSequence++;
	}

	private void enterDotClassMess() {
		this.isProcessingDotClass = true;
		fullyExitDotClassMess = false;
	}

	private boolean isDotClass(String name) {
		if (name.startsWith("class$")) {
			if (Character.isDigit(name.charAt(name.length() - 1))) {
				if (compilerHint != -1 && compilerHint != ECLIPSEJDT) {
					throw new RuntimeException("The Jacn is confused by the compiler type: " +
							"the naming convention of the synth class field is inconsistant");
				}
				else {
					compilerHint = ECLIPSEJDT;
				}
			}
			else {
				if (compilerHint != -1 && compilerHint != SUNJDK) {
					throw new RuntimeException("The Jacn is confused by the compiler type: " +
							"the naming convention of the synth class field is inconsistant");
				}
				else {
					compilerHint = SUNJDK;
				}
			}
			// TODO: other compilers: jrocket, jike, etc...
			return true;
		}
		return false;
	}

//	private FieldNode getField(String name) {
//		List l = springConfig.classNode.fields;
//		for (Iterator iter = l.iterator(); iter.hasNext();) {
//			FieldNode f = (FieldNode) iter.next();
//			if (f.name.equals(name)){
//				return f;
//			}
//		}
//		return null;
//	}

	/**
	 * method call
	 */
	public void visitMethodInsn(final int opcode, final String owner,
			final String methodName, final String desc) {
		
		if (isProcessingDotClass) {
			lastOpcode = opcode;
			this.insnSequence++;
			return;
		}
		
		boolean pushReturn  = true;
		Type[] args = Type.getArgumentTypes(desc);
		Type returnType =  Type.getReturnType(desc);
		Class ownerClass  = null;;
		try{
			ownerClass = Class.forName(owner.replace('/', '.'));
		} catch (ClassNotFoundException e) {
			notValid(e.getMessage());
		}

		if (ownerClass == Class.class && methodName.equals("getName")){
			// do nonthing. the class name is loaded at LDC instruction
			lastOpcode = opcode;
			this.insnSequence++;
			return;
		}

		switch (opcode) {
		case INVOKEINTERFACE:
		case INVOKEVIRTUAL:
		{
			int argLength = args.length;
			XmlElementObject[] argElems = new XmlElementObject[argLength];
			for (int i = 0; i < args.length; i++) {
				argElems[argLength - 1 - i] = pop(); 
				// I reverse the order here
			}
			XmlElementObject ownerObj = pop();

			if (ownerObj instanceof ThisVar) {
				if (methodName.equals("enableTx")) {
					FieldElementObj targetBean = (FieldElementObj)argElems[0];
					XmlElementObject txManager = argElems[1];
					PropertiesObject txProps = (PropertiesObject) argElems[2];

					ArrayObject interfaces = null;
					if (!(argElems[3] instanceof NullObject)) {
						interfaces = (ArrayObject) argElems[3];
					}
					ArrayObject preInterceptors = null;
					if (!(argElems[4] instanceof NullObject)) {
						preInterceptors = (ArrayObject) argElems[4];
					}
					ArrayObject postInterceptors = null;
					if (!(argElems[5] instanceof NullObject)) {
						postInterceptors = (ArrayObject) argElems[5];
					}

					
					FieldElementObj target = getFieldElement(targetBean.name);

					if (target.isSingleton()) {
						// use the convenient structure
						TxProxyObject proxy = TxProxyObject.txProxy(target);
						proxy.addProxyInterfaces(interfaces);
						proxy.addTxAttributes(txProps);
						proxy.addTxManager(txManager);
						proxy.addPreInterceptors(preInterceptors);
						proxy.addPostInterceptors(postInterceptors);
						springConfig.fldElems.put(proxy.getName(), proxy);
						
					}
					else {
//						if (preInterceptors != null || postInterceptors != null ) {
//							notValid("pre/post interceptors not supported in proxy none-singleton beans");
//						}
						TxInterceptor txInt = new TxInterceptor(targetBean.name);
						txInt.addTxAttributes(txProps);
						txInt.addTxManager(txManager);
						springConfig.synthesizedfldElems.put(txInt.getName(), txInt);

						ProxyFactoryField  proxy = ProxyFactoryField.proxy(target);
						proxy.addProxyInterfaces(interfaces);

						proxy.addInterceptor(preInterceptors);
						proxy.addInterceptor(txInt);
						proxy.addInterceptor(postInterceptors);
//						proxy.addPreInterceptors(preInterceptors);
//						proxy.addPostInterceptors(postInterceptors);
						springConfig.fldElems.put(proxy.getName(), proxy);
					}
					

					springConfig.synthesizedfldElems.put(target.name, target);
					break;
				} else if (methodName.equals("weaveAspects")) {
					int c = 0;
					FieldElementObj targetBean = (FieldElementObj)argElems[c++];
					// the pattern are simple *aaa or aaa*, not regex
					ArrayObject interfaces = null;
					ArrayObject patterns = null;
					ArrayObject advices = null;
					if (!(argElems[c] instanceof NullObject)) {
						interfaces = (ArrayObject) argElems[c]; 
					}
					c++;

					if ((argElems[c] instanceof NullObject)) {
						notValid("method naming pattern cannot be null"); 
					}
					else {
						 patterns = (ArrayObject) argElems[c];
					}
					
					c++;
					if ((argElems[c] instanceof NullObject)) {
						notValid("advices cannot be null"); 
					}
					else {
						advices = (ArrayObject) argElems[c];
					}
					
					FieldElementObj target = getFieldElement(targetBean.name);
					// note th target changes after calling the ctor of proxy. 
					ProxyFactoryField  proxy = ProxyFactoryField.proxy(target);
					proxy.addProxyInterfaces(interfaces);

					List refs = advices.e.getChildren();
					// each of it must be <ref bean="..."/>
					for (Iterator iter = refs.iterator(); iter.hasNext();) {
						Element e = (Element) iter.next();
						if (e.getName().equals("ref")) {
							String adviceName = e.getAttributeValue("bean");
							NameMatchMethodPointcutAdvisorField nmmpa = 
								new NameMatchMethodPointcutAdvisorField(adviceName, patterns);  
							springConfig.synthesizedfldElems.put(nmmpa.getName(), nmmpa);
							proxy.addInterceptor(nmmpa);
						}
						else if (e.getName().equals("bean")){
							notValid("advices must be fields.");
//							String adviceName = e.getAttributeValue("bean");
//							NameMatchMethodPointcutAdvisorField nmmpa = 
//								new NameMatchMethodPointcutAdvisorField(adviceName, patterns);  
//							springConfig.synthesizedfldElems.put(nmmpa.getName(), nmmpa);
//							proxy.addInterceptor(nmmpa);
						}
						else {
							notValid("advices must be fields.");
						}
					}
					//  create one NameMatchMethodPointcutAdvisor for each advice
					springConfig.fldElems.put(proxy.getName(), proxy); 
					// need to put in the fledElems
					// or the old target still there
					springConfig.synthesizedfldElems.put(target.name, target);
					break;
				} else {
					// shoud bring code of refbean etc here
				}
			}
			// let's see if setter
			
			if (methodName.startsWith("set")
					&& args.length == 1
					&& methodName.length() > 3 
					&& Character.isUpperCase(methodName.substring(3, 4).charAt(0))
					&& !AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) {
				// a setter. todo should check the return type to make sure
				// that
				
				String propName = ConvertUtil.getPropFromMethodName(methodName);
				XmlElementObject arg = argElems[0];
				Element oe = null;
				
				if (ownerObj instanceof ProxyFactoryField) {
					ProxyFactoryField proxy = (ProxyFactoryField) ownerObj;
					oe = proxy.getTarget().e;
					//assert (oe != null);
				}
				else if (ownerObj.isField()) {
					FieldElementObj fn = ((FieldElementObj)ownerObj);
					oe = getFieldElement(fn.name).e;
				}
				else if (ownerObj.isLocalVariable()) {
					String varName = ownerObj.name;
					oe = getVarElement(varName);
				}
				else {
					break;
				}

				if (arg instanceof FieldElementObj) {
					String beanName = ((FieldElementObj)arg).name;

					String className = arg.getClassName();
					Class argClass = null;
					try{
						argClass = Class.forName(className);
					} catch (ClassNotFoundException e) {
						notValid(e.getMessage());
					}
					if (FactoryBean.class.isAssignableFrom(argClass)) {
						// find out if the setter takes the factoryBean, not the product
						Method[] meths = ownerClass.getMethods();
						for (int i = 0; i < meths.length; i++) {
							Method method = meths[i];
							if ((method.getModifiers() & Modifier.PUBLIC) == Modifier.PUBLIC) {
								if (method.getName().equals(methodName)) {
									Class[] argTypes = method.getParameterTypes();
									if (argTypes.length == 1 
											&& argTypes[0].isAssignableFrom(argClass)
											&& FactoryBean.class.isAssignableFrom(argTypes[0])) {
										beanName = "&" + beanName;
										break;
										// the above logic is not bullet proof!
									}
								}
							}
						}
					}
					oe.addContent(newPropElement(propName, ConvertUtil.newRefBean(beanName)));
				}
				else if (arg instanceof VarElementObj) {
					// use an inline bean def
					oe.addContent(newPropElement(propName, ((VarElementObj)arg).e));
				}
				else {
					oe.addContent(newPropElement(propName, ((XmlElementObject)arg).e));
				}
			} // end of if setter
			else {
				// we take properties.put/setProperty method
				if (owner.equals("java/util/Properties")
						&& (methodName.equals("setProperty")
								|| methodName.equals("put"))
								){
					// support only const key and value
					ConstObject val = (ConstObject) argElems[1];
					ConstObject key = (ConstObject) argElems[0];
					PropertiesObject propo = (PropertiesObject) ownerObj;
					propo.put(key, val);
				}
				else if(List.class.isAssignableFrom(ownerClass)
						&& methodName.equals("add")
						&& args.length == 1) {
					// an add operaitio on list
					ListObject var = (ListObject) ownerObj;
					var.addValue(argElems[0]);
				}
				else if(Set.class.isAssignableFrom(ownerClass)
						&& methodName.equals("add")
						&& args.length == 1) {
					// an add operaitio on list
					SetObject var = (SetObject) ownerObj;
					var.addValue(argElems[0]);
				}
				
				else if(Map.class.isAssignableFrom(ownerClass)
						&& methodName.equals("put")
						&& args.length == 2) {
					XmlElementObject val = argElems[1];
					ConstObject key = (ConstObject) argElems[0];
					MapObject mo = (MapObject)ownerObj;
					mo.addValue(key.o.toString(), val);
				}
				else {
					if(methodName.equals("getObject")){
							// see if this is a factoryBean call
						if (FactoryBean.class.isAssignableFrom(ownerClass)){
							pushReturn = false;
							push(ownerObj); // the result is the owner for factorybean
							break;
						}
					}
					else if(methodName.equals("refBean")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						// todo: remove the hardcoded meth name
						ConstObject co = (ConstObject) argElems[0];
						String refId = co.toString();
						XmlElementObject xe = new XmlElementObject(returnType);
						xe.e  =ConvertUtil.newRefBean(refId); 
						push(xe);
						pushReturn = false;
					}
					else if(methodName.equals("lazyInit")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						// todo: remove the hardcoded meth name
						XmlElementObject co = argElems[0];
						if (co.isField()) {
							FieldElementObj fe = getFieldElement(co.name);
							fe.lazyInit();
							//fe.e.getAttributes().add(new Attribute("lazy-init", "true"));
						}
					}
					else if(methodName.equals("autoWireByType")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						XmlElementObject co = argElems[0];
						if (co.isField()) {
							FieldElementObj fe = getFieldElement(co.name);
							//fe.e.getAttributes().add(new Attribute("autowire", "byType"));
							fe.autoWireByType();
						}
					}
					else if(methodName.equals("autoWireByName")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						XmlElementObject co = argElems[0];
						if (co.isField()) {
							FieldElementObj fe = getFieldElement(co.name);
							//fe.e.getAttributes().add(new Attribute("autowire", "byName"));
							fe.autoWireByName();
						}
					}
					else if(methodName.equals("loadPlaceholderProperties")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						ArrayObject ao = (ArrayObject) argElems[0];
						String ppConfigurerName = "_ppConfigurer";
						FieldElementObj f = new FieldElementObj(
								PropertyPlaceholderConfigurer.class.getName(), 
								ppConfigurerName,
								true);
						Element locs = ConvertUtil.newPropElement("locations");
						locs.addContent(ao.e);
						f.e.addContent(locs);
						springConfig.synthesizedfldElems.put(ppConfigurerName, f);
					}
					else if(methodName.equals("setWebScopeSession")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						ArrayObject ao = (ArrayObject) argElems[0];
						Element e = ao.e;
						List refs = e.getChildren();
						for (Iterator iter = refs.iterator(); iter.hasNext();) {
							Element ee = (Element) iter.next();
							if (ee.getName().equals("ref")) {
								String beanName = ee.getAttribute("bean").getValue();
								if (WebScope.APPLICATION_SCOPE.equals(
										this.springConfig.getBeanScopeMap().get(beanName))) {
									notValid("setWebScopeSession() can be applied to none-static fields only");
								}
								this.springConfig.getBeanScopeMap().put(
										beanName, 
										WebScope.SESSION_SCOPE
								);
							}
							else {
								notValid("setWebScopeSession() can be applied to fields only");
							}
						}
					}
					else if(methodName.equals("setWebScopeRequest")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						ArrayObject ao = (ArrayObject) argElems[0];
						Element e = ao.e;
						List refs = e.getChildren();
						for (Iterator iter = refs.iterator(); iter.hasNext();) {
							Element ee = (Element) iter.next();
							if (ee.getName().equals("ref")) {
								String beanName = ee.getAttribute("bean").getValue();
								if (WebScope.APPLICATION_SCOPE.equals(
										this.springConfig.getBeanScopeMap().get(beanName))) {
									notValid("setWebScopeRequest() can be applied to none-static fields only");
								}
								this.springConfig.getBeanScopeMap().put(
										beanName, 
										WebScope.REQUEST_SCOPE
								);
							}
							else {
								notValid("setWebScopeRequest() can be applied to fields only");
							}
						}
					}
					else if(methodName.equals("bindValue")
							&& AbstractJacnConfigFile.class.isAssignableFrom(ownerClass)) { 
						ConstObject co = (ConstObject) argElems[0];
						this.valueElementNeedType  = co.e;
						String el = co.e.getText().trim();
						if (el.startsWith("#{") && el.endsWith("}")) {
							
						}
						else {
							co.e.setText("#{" + el + "}");
						}
						
						this.needDecorating = true;
						push(co);
						pushReturn = false;
						// to be decorated in checkcast
					}
					
					else {
						if(ownerObj.isField() || ownerObj.isLocalVariable()) {
							if (operands.size() > 0 ) {
								// beanfactory method
								Element e = new Element("bean");
								addAttr(e, "id", getTmpVarName());
								addAttr(e, "factory-bean", ownerObj.name);
								addAttr(e, "factory-method", methodName);
								for (int i = 0; i < argElems.length; i++) {
									XmlElementObject ar = argElems[i];
									Element are;
									if (ar.isField()/* || ar.isLocalVariable()*/) {
										are = newConstructorArg(newRefBean(ar.name));
									} else {
										are = newConstructorArg(ar.e);
									}
									e.addContent(are);
								}
								XmlElementObject result = new XmlElementObject(
										returnType.getDescriptor());
								result.e = e;
								result.typeDesc = returnType.getDescriptor();
								push(result);
								pushReturn = false;
								break;
							}
							else {
								if (!ownerObj.isField()) {
									notValid("method not supported: " + methodName);
								}
								// general method invoking mapped to
								// methodinovkingfactorybean
								/*
								 * <bean id="does-not-matter"
								 * class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
								 * <property name="targetObject" ref="foo" />
								 * <property name="targetMethod"
								 * value="processClassName" /> <property
								 * name="arguments"> <list> <value>Hello</value>
								 * </list> </property> </bean>
								 */
								String fn = getTmpVarName();
								FieldElementObj fe = new FieldElementObj(
										MethodInvokingFactoryBean.class.getName(), 
										fn,
										true
										);
								if (ownerObj instanceof ProxyFactoryField) {
									fe.e.addContent(newRefPropElement(
											"targetObject", 
											((ProxyFactoryField)ownerObj).getTarget().name));
								}
								else {
									fe.e.addContent(newRefPropElement("targetObject", ownerObj.name));
								}
								fe.e.addContent(newValuePropElement("targetMethod", methodName));
								if (argLength > 0) {
									Element le = newListElement();
									for (int i = 0; i < argElems.length; i++) {
										XmlElementObject ar = argElems[i];
										Element are;
										if (ar.isField()/* || ar.isLocalVariable()*/) {
											are = newRefBean(ar.name);
										} else {
											are = ar.e;
										}
										le.addContent(are);
									}
									fe.e.addContent(newPropElement("arguments", le));
								}
								springConfig.synthesizedfldElems.put(fn, fe);
							}
						}
					}
				}
			}
			break;
		}
		case INVOKESPECIAL:  // <init> call
		{
			int argLength = args.length;
			XmlElementObject[] argElems  = new XmlElementObject[argLength];
			for (int i = 0; i < args.length; i++) {
				argElems[argLength -1 - i] = pop(); // I reverse the order here
			}
			// XmlElementObject factoryBean = pop();
			pop(); // the dupped owner, throw away
			XmlElementObject ob = peek();
			
			// collection type don't take args
			// safe to assume that args are for constructor DI
			int argLen = argElems.length;
			if (owner.indexOf("$")> 0 && argLength > 0 && argElems[argLength - 1] instanceof NullObject) {
				// call the synth <init> of the inner class. drop the last arg
				argLen--;
			}
			for (int i = 0; i < argLen; i++) {
				XmlElementObject ar = argElems[i];
				Element are; 
				if (ar.isField()) {// || ar.isLocalVar) {
					are = newConstructorArg(newRefBean(ar.name)); 
				}
				else {
					are = newConstructorArg(ar.e);  
					// TODO should carry type attribute
				}
				ob.e.addContent(are);
			}
			pushReturn = false;
			break;
		}
		case INVOKESTATIC:
		{
			// cases: 1. owner is Jac plugin. 2. owner is a static factory
			// <bean id="exampleBean" class="examples.ExampleBean2"
			// factory-method="createInstance"/>
			// Class.forName(), synth body for .class syntax
			if (JacnPlugin.class.isAssignableFrom(ownerClass)){
				notValid("not supported yet");
			}
			else if(ownerClass.equals(Class.class) && methodName.equals("forName")) {
// commented out. push the const at LDC instead
// push(new ConstObject(currentDotClassName));
			}
			else {
				// similar to factory method on bean instance
				int argLength = args.length;
				XmlElementObject[] argElems  = new XmlElementObject[argLength];
				for (int i = 0; i < args.length; i++) {
					argElems[argLength -1 - i] = pop(); // I reverse the order
														// here
				}
				// XmlElementObject factoryBean = pop();
				
				Element e = new Element("bean");
				addAttr(e, "id", getTmpVarName());
				addAttr(e, "class", owner.replace('/', '.'));
				addAttr(e, "factory-method", methodName);
				for (int i = 0; i < argElems.length; i++) {
					XmlElementObject ar = argElems[i];
					Element are; 
					if (ar.isField() /*|| ar.isLocalVar*/) {
						are = newConstructorArg(newRefBean(ar.name)); 
					}
					else {
						are = newConstructorArg(ar.e);
					}
					e.addContent(are);
				}
				XmlElementObject result = new XmlElementObject(returnType.getDescriptor());
				result.e = e;
				result.typeDesc = returnType.getDescriptor();
				push(result);
				pushReturn = false;
				break;
			}
			break;
		}
		default:
			throw new RuntimeException("unexpected case");
		}
		lastOpcode = opcode;
		// todo push the return value of function call to the operand stack.
		// lucky we're using setters now and there is no return value
		if (!returnType.equals(Type.VOID_TYPE) && pushReturn) {
			XmlElementObject e = new XmlElementObject(returnType.getDescriptor()); 
			// todo: extract more from the descriptor
			e.typeDesc = returnType.getDescriptor();
			push(e);
		}

		pushReturn = true;
		this.insnSequence++;
	}


	private Element newListElement() {
		return new Element("list");
	}

	/*
	 * create a <property name="ccc" ref="beanname"/>
	 */
	private Element newRefPropElement(String propName, String refName) {
		Element pe = new Element("property");
		addAttr(pe, "name", propName);
		addAttr(pe, "ref", refName);
		return pe;
	}
	/*
	 * create a <property name="ccc" ref="beanname"/>
	 */
	private Element newValuePropElement(String propName, String value) {
		Element pe = new Element("property");
		addAttr(pe, "name", propName);
		addAttr(pe, "value", value);
		return pe;
	}
	
	
	private Element newConstructorArg(Element element) {
		Element e = new Element("constructor-arg");
		e.addContent((Element) element.clone());
		return e;
	}

	private void addAttr(Element e, String a, String v) {
		e.getAttributes().add(new Attribute(a, v));
	}

	private Object push(XmlElementObject e) {
		return operands.push(e);
	}

	private Element newPropElement(String propName, Element element) {
		Element r = new Element("property");
		r.getAttributes().add(new Attribute("name", propName));
		r.addContent((Element) element.clone());
		return r;
	}

	static Element newPropertiesProp(String propName, String v) {
		Element r = new Element("prop");
		r.getAttributes().add(new Attribute("key", propName));
		r.setText(v);
		return r;
	}

	private FieldElementObj getFieldElement(String name) {
		return (FieldElementObj) springConfig.fldElems.get(name);
	}

	public void visitJumpInsn(final int opcode, final Label label) {
		if (!isProcessingDotClass) {
			notValid("visitJumpInsn");
		} else { // in dotClass processing
			if (opcode == GOTO || opcode == IFNULL || opcode == IFNONNULL) {
				if (opcode == IFNONNULL){
					// need to find the end lable for the .class construct
					this.dotClassEndLabel = label;
//					if (compilerHint == ECLIPSEJDT) {
//						// restore the thrown away DUP ? 
//						push(peek());
//					}
				}
			} else if (opcode == IF_ICMPEQ) {
			} else if (opcode == IF_ICMPNE) {
			} else if (opcode == IF_ICMPLT) {
			} else if (opcode == IF_ICMPGE) {
			} else if (opcode == IF_ICMPGT) {
			} else if (opcode == IF_ICMPLE) {
			} else if (opcode == IF_ACMPEQ) {
			} else if (opcode == IF_ACMPNE) {
			} else if (opcode == IFEQ) {
			} else if (opcode == IFNE) {
			} else if (opcode == IFLT) {
			} else if (opcode == IFGE) {
			} else if (opcode == IFGT) {
			} else if (opcode == IFLE) {
			} else {
			}
		}
		lastOpcode = opcode;
		this.insnSequence++; // todo verify that a frame is created for label
	}

	public void visitLabel(final Label label) {
		//currentLine = label. // the label line info is package scoped!
		if (isProcessingDotClass) {
			if (label.equals(this.dotClassEndLabel)){
				this.isProcessingDotClass = false;
				this.fullyExitDotClassMess  = compilerHint == ECLIPSEJDT;
			}
		}
		lastOpcode = -1;
		this.insnSequence++; // todo verify that a frame is created for label
	}

	public void visitLdcInsn(final Object cst) {
		if (isProcessingDotClass) {
			// should be the class name for .class
			//this.
			String cn = (String) cst;
			this.currentDotClassName = cn;
//			try {
// do not load the class to avoid issues
//				Class c = Class.forName(cn);
//				springConfig.dotClassNames.put(this.currentDotClassName, c);
//			} catch (ClassNotFoundException e) {
//				notValid(".class resolving problem:" + e);
//			}
			push(new ConstObject(currentDotClassName));
		}
		else {
			push(newConstObject(cst));
		}
		lastOpcode = LDC;
		this.insnSequence++;
	}

	private ConstObject newConstObject(Object cst) {
		return new ConstObject(cst);
	}

	public void visitIincInsn(final int var, final int increment) {
		notValid("visitIincInsn");
	}

	public void visitTableSwitchInsn(final int min, final int max,
			final Label dflt, final Label labels[]) {
		notValid("visitTableSwitchInsn");
	}

	public void visitLookupSwitchInsn(final Label dflt, final int keys[],
			final Label labels[]) {
		notValid("visitLookupSwitchInsn");
	}


	public void visitMultiANewArrayInsn(final String desc, final int dims) {
		notValid("visitMultiANewArrayInsn");
	}

	public void visitTryCatchBlock(final Label start, final Label end,
			final Label handler, final String type){
		//notValid("visitTryCatchBlock");
		// ignore
	}

	public void visitLocalVariable(final String name, final String desc,
			final String signature, final Label start, final Label end,
			final int index) {
//		if (springConfig.fldElems.keySet().contains(name)) {
//			throw new RuntimeException(
//					"cannot define a local variable with the same name as a field: "
//					+ name);
//		}
	}

	public void visitLineNumber(final int line, final Label start) {
		this.currentLine = line;
		lastOpcode = -1;
		this.insnSequence++;
	}

	public void visitMaxs(final int maxStack, final int maxLocals) {
		text.add("mg.endMethod();\n");
		lastOpcode = -1;
	}

	public void visitEnd() {
		// does nothing
	}

	public String getMethodName() {
		return methodName;
	}

	public void setMethodName(String methodName) {
		this.methodName = methodName;
	}
	private void notValid(String msg) {
		throw new RuntimeException("instruction not supported: " + msg);
	}
	
	ArrayList opStack = new ArrayList();
	
	MyStack operands = new MyStack();

	private Element newValueElement(String value) {
		Element e = new Element("value");
		e.setText(value);
		return e;
	}

	Element getVarElement(String varName) {
		return (Element) ((XmlElementObject)this.locals.get(varName)).e;
	}
	
	static int tmpVarNum = 0;
	
	static synchronized String getTmpVarName() {
		return "__" + tmpVarNum++;
	}
	
	static Element newRefBean(String beanId) {
		Element e = new Element("ref");
		e.getAttributes().add(new Attribute("bean", beanId));
		return e;
	}

	private static Element newBeanDef(String className, String beanId) {
		Element e  = new Element("bean");
		e.getAttributes().add(new Attribute("id", beanId));
		e.getAttributes().add(new Attribute("class", className));
		return e;
	}

	Map varNames = new HashMap();
	
	private String getLocalVarName(int i) {
		if (i == 0) {
			return "this";
		}
		Integer in = new Integer(i);
		String varName = null;
		if (varNames.containsKey(in)) {
			return (String) varNames.get(in);
		}
		else {
		// let's forget about original names
			if (false && localVars.size() > 0) {
				// with debug info
				LocalVariableNode lv = (LocalVariableNode) localVars.get(i);
				varName = lv.name;
				varNames.put(in, varName);
			}
			else {
				varName = getTmpVarName(i);
				varNames.put(in, varName);
			}
			
		}
		return varName;
	}
}
