package bran.spring.jacn;


import org.jdom.Attribute;
import org.jdom.Element;
import org.springframework.transaction.interceptor.TransactionProxyFactoryBean;


public class TxProxyObject extends ProxyFactoryField {
	
	public static TxProxyObject txProxy(FieldElementObj target) {
		return new TxProxyObject(target);
	}

	Class proxyClass;
	String name;
	
	/**
	 * will alway do <ref bean="...">
	 * @param target
	 */
	private TxProxyObject(FieldElementObj target) {
		super(TransactionProxyFactoryBean.class.getName(), target.name, false);

		Attribute idAttr = target.e.getAttribute("id");
		String oldId = idAttr.getValue();
		String newId = oldId + JacnClassVisitor.PROXY_TARGET_APPENDIX;
		idAttr.setValue(newId);
		target.name = newId;
		
		super.target = target;
		this.name = oldId;
		
		e = new Element("bean");
		e.getAttributes().add(new Attribute("id", name));
		e.getAttributes().add(new Attribute("class", TransactionProxyFactoryBean.class.getName()));
		Element tarEle = new Element("property");
		tarEle.getAttributes().add(new Attribute("name", "target"));
		Element refe = new Element("ref");
		refe.getAttributes().add(new Attribute("bean", target.name));
		tarEle.addContent(refe);
		e.addContent(tarEle);
		if (target.isSingleton()) {
			e.getAttributes().add(new Attribute("singleton", "true"));
		}
		else {
			// let's lay init it
			e.getAttributes().add(new Attribute("lazy-init", "true"));
		}
	}
	
	void addTxManager(XmlElementObject txManObj) {
		Element te = new Element("property");
		te.getAttributes().add(new Attribute("name", "transactionManager"));
		if (txManObj.isField()) {
			Element refe = new Element("ref");
			refe.getAttributes().add(new Attribute("bean", txManObj.name));
			te.addContent(refe);
		}
		else /*if (txManObj.isLocalVariable())*/ {
			te.addContent((Element) txManObj.e.clone());
		}
		e.addContent(te);
	}

	void addTxAttributes(PropertiesObject props) {
		Element te = new Element("property");
		te.getAttributes().add(new Attribute("name", "transactionAttributes"));
		te.addContent( (Element)props.e.clone());
		e.addContent(te);
	}

	void addPreInterceptors(ArrayObject inters) {
		if (inters != null && inters.getArrayLength() > 0) {
			Element te = new Element("property");
			te.getAttributes().add(new Attribute("name", "preInterceptors"));
			te.addContent(inters.e);
			e.addContent(te);
		}
	}
	
	void addPostInterceptors(ArrayObject inters) {
		if (inters != null && inters.getArrayLength() > 0) {
			Element te = new Element("property");
			te.getAttributes().add(new Attribute("name", "postInterceptors"));
			te.addContent((Element) inters.e.clone());
			e.addContent(te);
		}
	}
}
