package bran.spring.jacn;

import org.jdom.Element;


/**
 * stack object that can be represented by an Spring XML node
 * @author bran
 *
 */
class XmlElementObject implements Cloneable{
	public String name;
	protected boolean isField = false;
	protected boolean isLocalVar = false;
	int localVarIndex;
	String typeDesc;  // internal name:  java/util/something etc... 
	Object o;

	/**
	 * store the XML representation of the bean
	 */
	Element e;
	boolean isArray = false;
	boolean isProperties = false;
	protected String className = null;

	XmlElementObject(Object cst) {
		this.o = cst;
		name = JacnMethodVisitor.getTmpVarName();
	}
	public Object clone()  {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			return new Object();
		}
	}

	void setE(Element e) {
		this.e = e;
	}
	
	boolean isArray() {
		if (this instanceof ArrayObject)
			return true;
		return this.isArray;
	}
	
	boolean isField() {
		if (this instanceof FieldElementObj)
			return true;
		return isField;
	}
	
	boolean isLocalVariable() {
		if (this instanceof VarElementObj)
			return true;
		return isLocalVar;
	}
	public String getClassName() {
		if (className == null) {
			this.className = ConvertUtil.desc2reg(this.typeDesc); 
		}
		return className;
	}
	public void setClassName(String implClassName) {
		this.className  = implClassName;
	}
}