package bran.spring.jacn.faces;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 * rep a flow and all its beans associated with it
 * 
 * @author bran
 * 
 */
public class Flow implements Serializable{
	String flowid;

	FlowManager fm;

	Map flowBeans = new HashMap(); // [id, bean]

	private FlowController flowController;

	private String controllerName;

	public FlowManager getFm() {
		return fm;
	}

	public void setFm(FlowManager fm) {
		this.fm = fm;
	}

	public Flow(String flowid, FlowManager fm) {
		this.flowid = flowid;
		this.fm = fm;
	}

	public Flow(FlowController fc) {
		this.flowController = fc;
	}

	public void putBean(String id, Object bean) {
		flowBeans.put(id, bean);
	}

	public String getFlowid() {
		return flowid;
	}

	public void setFlowid(String flowid) {
		this.flowid = flowid;
	}

	public FlowController getFlowController() {
		return flowController;
	}

	public void setFlowController(FlowController flowController) {
		this.flowController = flowController;
	}

	/**
	 * set the name of the controller.
	 * 
	 * @param name
	 *            The name is used to define the managed bean in Jacn context.
	 */
	public void setControllerName(String name) {
		this.controllerName = name;
	}

	public Object getBean(String name) {
		if (name.equals(this.controllerName)) {
			return flowController;
		}
		else {
			return this.flowBeans.get(name);
		}
	}

	public String getControllerName() {
		return controllerName;
	}

}
