package bran.spring.jacn.faces;

import java.io.Serializable;

/**
 * 
 * @author bran
 *
 */
public interface FlowController extends Serializable {
	/**
	 * the entry method for the flow.
	 *  
	 * @param arg  anything the parent passes to this.
	 * @return the outcome that detemines the first view to go
	 * for this flow.
	 * 
	 * Note: Will be called by the FlowManager. Not supposed to be called by a flow controller 
	 * directly. 
	 */
	String begin(Object arg);
//	void init(Object arg);
	
	/**
	 * what's the use case for this?
	 * 
	 * @return
	 * @deprecated
	 */String end();
	
	 /**
	  * this is the call back for the kid flow to return to the paused parent flow
	  * 
	  * @param childFlow
	  * @return the directive for the next view
	  */
	String resume(FlowController childFlow);

	/**
	  * injection point
	  * @param flowManager
	  */
	void setFlowManager(FlowManager flowManager);

//	/**
//	 * injection point. The FlowManager will call this. Not supposed to be called by end users
//	 * @param parentFlow
//	 */
//	void setParentFlow(FlowController parentFlow);
//
//	FlowController getParentFlow();

	/**
	 * the view id of the default view of this controller;
	 */
	String getHomeView();
	void setHomeView(String vid);
}
