package bran.jacn.test;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;
import bran.spring.jacn.JacnApplicationContext;

public class SimpleFlatJacnApp {

	private static final String HELLO = "hello";

	public static void main(String[] args) throws Exception {
		System.out.println(ConvertUtil.jacn2Xml(Jacn_foo.class));
		JacnApplicationContext ctx = new JacnApplicationContext(Jacn_foo.class);
		Foo foo = (Foo) ctx.getBean("foo");
		if(HELLO.equals(foo.getBar().getMsg())) {
			System.out.println("good");
		}
		else {
			System.out.println("bad");
		}
	}
	
	static class Foo {
		Bar bar;
		public Bar getBar() {return bar;}
		public void setBar(Bar bar) {this.bar = bar;}
	}

	static class Bar {
		String msg;
		private Bar(String msg) {this.msg = msg;}
		public String getMsg() {return msg;}
	}

	/**
	 * the configuration file 
	 */
	static class Jacn_foo extends AbstractJacnConfigFile{
		static Foo foo;
		static Bar bar;
		public void wire() throws Exception {
			bar = new Bar(HELLO);
			foo.setBar(bar);
		}
	}
}
