/*
 * $Log$
 * Revision 1.2  2006/07/02 04:59:46  branaway
 * added testcase for init and destroy, and other trivial
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import bran.spring.jacn.AbstractJacnConfigFile;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */
public class TestArray extends JacnTestCase {

	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacn_array.class};
	}

	public void testArrayRefElement() throws Exception {
		Foo foo = (Foo) getCtx().getBean("foo");
		assertTrue(foo.getObjs()[0] instanceof Bar);
		assertTrue(foo.getObjs()[1].equals("bar"));
		assertTrue(foo.getObjs()[2].equals("foo"));
		assertTrue(foo.getBars()[0] instanceof Bar);
		
	}
	
	/**
	 * the config file used for this test
	 * @author bran
	 *
	 */
	public static class Jacn_array extends AbstractJacnConfigFile {
		static Foo foo;
		static Bar bar;
		
		public void wire() throws Exception {
			String s = "foo";
			foo.setBars(new Bar[] {bar});
			foo.setObjs(new Object[] {bar, "bar", s});
		}
	}
}
