/*
 * $Log$
 * Revision 1.1  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import bran.spring.jacn.AbstractJacnConfigFile;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */
public class TestAutoWire extends JacnTestCase {

	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacnfig.class};
	}

	public void testWirebyNameAndType() throws Exception {
		Foo foo = (Foo) getCtx().getBean("foo");
		
		assertNotNull(foo.getBar());
		assertNull(foo.getBar2());
		
		foo = (Foo) getCtx().getBean("foo1");
		assertNotNull(foo.getBar());
		assertNotNull(foo.getBar2());
		
		
	}
	
	static class Foo {
		Bar bar;

		public Bar getBar() {
			return bar;
		}

		public void setBar(Bar bar) {
			this.bar = bar;
		}
		
		Bar2 bar2;

		public Bar2 getBar2() {
			return bar2;
		}

		public void setBar2(Bar2 bar2) {
			this.bar2 = bar2;
		}
	}
	
	static class Bar {	}
	
	static class Bar2{	}
	
	
	/**
	 * the config file used for this test
	 * @author bran
	 *
	 */
	public static class Jacnfig extends AbstractJacnConfigFile {
		static Foo foo;
		static Bar bar;
		static Foo foo1;
		static Bar2 barbar;
		
		public void wire() throws Exception {
			autoWireByName(foo);
			autoWireByType(foo1);
		}
	}
}
