package bran.jacn.test;

import java.io.IOException;
import java.util.List;

import junit.framework.TestCase;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;

public class TestBindValue extends TestCase {
	public void testBindValueWithoutCurlie() throws IOException, JDOMException {
		Document dom = ConvertUtil.jacn2JDom(Jacn.class);
		System.out.println(ConvertUtil.jacn2Xml(Jacn.class));
		// what to see
		// <property name="bar"><value type="Bar">#{bar}</value></property>;
		Element ve = (Element) XPath.selectSingleNode(dom, 
				"/beans/bean[@id='foo']/property/value");
		
		assertEquals(Bar.class.getName(), ve.getAttributeValue("type"));
		assertEquals("#{bar}", ve.getTextTrim());
	}

	static class Foo{
		Bar bar;

		public Bar getBar() {
			return bar;
		}

		public void setBar(Bar bar) {
			this.bar = bar;
		}
		
	}
	static class Bar{};
	
	static class Jacn extends AbstractJacnConfigFile {

		Foo foo;
		Bar bar;
		public void wire() throws Exception {
			foo.setBar((Bar) bindValue("bar"));
		}
		
	}
}
