package bran.jacn.test;

import java.util.HashMap;
import java.util.Map;


import bran.spring.jacn.AbstractJacnConfigFile;

public class TestClassForName extends JacnTestCase {
	
	protected Class[] getConfigClasses() {
		return new Class[]{Jacn_foo.class};
	}

	public void testClass4Name() throws Exception {
		Foo foo = (Foo) getCtx().getBean("foo");
		assertEquals(Foo.class.getName(), foo.getClassName());
		assertEquals(Foo.class, foo.getCls());
		assertEquals(Foo.class.getName(), foo.getMap().get("name"));
	}
	
	static class Jacn_foo extends AbstractJacnConfigFile{
		static Foo foo;
		public void wire() throws Exception {
			// it's very common in config files to set a class name on a property
			// the type-safe way of doing it is to use Foo.class.getName() pattern
			// instead of using a String. 
			foo.setClassName(Foo.class.getName());
			foo.setCls(Foo.class);
			
			Map m = new HashMap(); {
	            m.put("name", Foo.class.getName());
			}
			foo.setMap(m);
		}
	}
}
