package bran.jacn.test;


import junit.framework.TestCase;

import org.springframework.context.ApplicationContext;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;
import bran.spring.jacn.JacnApplicationContext;

public class TestCtorSetterMix extends TestCase {
	public void testOrderOfInvocation() throws Exception {
		System.out.println(ConvertUtil.jacn2Xml(Jacn.class));
		ApplicationContext ctx = new JacnApplicationContext(Jacn.class);
		Foo foo = (Foo)ctx.getBean("foo");
		assertEquals("me", foo.getMe());
		assertEquals("you", foo.getYou());
		assertEquals("him", foo.getHim());
	}
	
	static class Foo {
		String me, you, him;

		private Foo(String me) {
			this.me = me;
		}

		public String getMe() {
			return me;
		}

		public void setMe(String me) {
			this.me = me;
		}

		public String getYou() {
			return you;
		}

		public void setYou(String you) {
			this.you = you;
		}

		public String getHim() {
			return him;
		}

		public void setHim(String him) {
			this.him = him;
		}
	}
	static class Jacn extends AbstractJacnConfigFile {
		static Foo foo;
		public void wire() throws Exception {
			//the current bug will result in the loss of the first setter call
			foo.setYou("you");
			foo = new Foo("me");
			foo.setHim("him");
		}
	}
}
