/*
 * $Log$
 * Revision 1.2  2005/09/08 14:53:37  branaway
 * fixed issues with .class in jdk5
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import java.util.Properties;

import bran.spring.jacn.AbstractJacnConfigFile;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */
public class TestDotClassInProperty extends JacnTestCase {

	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacn_dotClassProp.class};
	}

	public void testDotClass() throws Exception {
		Foo foo = (Foo) getCtx().getBean("foo");
		Properties p = foo.getProps();
		assertEquals(Foo.class.getName(), p.get("p1")); 
	}
	
	/**
	 * the config file used for this test
	 * @author bran
	 *
	 */
	public static class Jacn_dotClassProp extends AbstractJacnConfigFile {
		static Foo foo;
		
		public void wire() throws Exception {
			Properties vp = new Properties();
			vp.put("p1", Foo.class.getName());
			foo.setProps(vp);
		}
	}
}
