package bran.jacn.test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.config.ListFactoryBean;


import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;
import bran.spring.jacn.JacnApplicationContext;

public class TestFactoryBean extends TestCase {

	public void testSingletone() throws Exception {
		JacnApplicationContext ctx = new JacnApplicationContext(
				new Class[] {Jacn_factoryBean.class, Jacn_fb.class});
		Foo foo = (Foo) ctx.getBean("foo");
		assertEquals(foo.getListProp().size(), 1);

		Foo foo1 = (Foo) ctx.getBean("foo1");
		assertEquals(foo1.getListProp().size(), 1);
	}
	
	// get the factory bean instance itself
	public void testFactoryBeanInstanceXml() throws Exception {
		String[] xmls = new String[] {"/bran/jacn/test/Factory.xml"};
		JacnApplicationContext wac = new JacnApplicationContext(null, xmls, true);
		Foo f = (Foo) wac.getBean("foo");
		assertTrue(FactoryBean.class.isAssignableFrom(f.getFactoryBean().getClass()));
	}

	// get the factory bean instance itself
	public void testFactoryBeanInstance() throws Exception {
		JacnApplicationContext ctx = new JacnApplicationContext(
				new Class[] {Jacn_factoryBean.class, Jacn_fb.class});
		Foo foo = (Foo) ctx.getBean("foo");
		assertTrue(FactoryBean.class.isAssignableFrom(foo.getFactoryBean().getClass()));
		Foo foo1 = (Foo) ctx.getBean("foo1");
		assertTrue(FactoryBean.class.isAssignableFrom(foo1.getFactoryBean().getClass()));
	}
	
	static class Jacn_factoryBean extends AbstractJacnConfigFile{

		static Foo foo;
		static Foo foo1;
		static ListFactoryBean lfb;// = new ListFactoryBean();
		
		public void wire() throws Exception {
			List list = new ArrayList();
			list.add("list value 1");

			lfb.setSourceList(list);
			//lfb.setTargetListClass(ArrayList.class);  // .class not supported?
			foo.setListProp((List) lfb.getObject());   // the pattern of factoryBean usagefoo.setBar((Bar) refBean("bar"));
			foo1.setListProp((List) lfb);  // a shortcut of using factorybean
			
			foo.setFactoryBean(lfb);  // set the factoryBean instance itself  on the bean
			foo1.setFactoryBean(Jacn_fb.lfb1);
		}
	}

	static class Jacn_fb extends AbstractJacnConfigFile{

		static ListFactoryBean lfb1;// = new ListFactoryBean();
		
		public void wire() throws Exception {
			List list = new ArrayList(); {
				list.add("list value 1");
			}
			lfb1.setSourceList(list);
		}
	}

	public static void main(String[] args) throws IOException {
		System.out.println(ConvertUtil.jacn2Xml(Jacn_factoryBean.class));
	}
}
