package bran.jacn.test;

import java.io.IOException;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;

public class TestFactoryMethod extends JacnTestCase {

	protected Class[] getConfigClasses() {
		return new Class[] {
				Jacn_factoryMethod.class
		};
	}

	public void testFactoryMethods() throws Exception {
		AA a= (AA) getCtx().getBean("a");
		//assertEquals(a.getB1().p1, "hello");
		assertEquals(a.getB2().p1, "hello1");
		
		BB b = (BB) getCtx().getBean("b");
		assertEquals(b.p1, "hello");
	}
	
	static class Jacn_factoryMethod extends AbstractJacnConfigFile {
		static AA a;
		static BBFactory bbf;
		BB b;
		public void wire() throws Exception {
			a.setB1(bbf.newInstance("hello", "b1")); // not supported prior to spring 1.2.3
			a.setB2(BBFactory.newInstanceStatic("hello1", "b2"));
			b = new BB("hello", "b");
		}
	}
	public static void main(String[] args) throws IOException {
		System.out.println(ConvertUtil.jacn2Xml(Jacn_factoryMethod.class));
	}

 }
