/*
 * $Log$
 * Revision 1.1  2006/07/02 04:59:46  branaway
 * added testcase for init and destroy, and other trivial
 *
 * Revision 1.3  2005/08/22 17:59:11  branaway
 * use a simple way to verify the timing a object creation.
 *
 * Revision 1.2  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/19 19:21:31  branaway
 * added layInit. Added build.xml
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.JacnApplicationContext;

/**
 * test specifying destroy-method by calling the destroy method in the destroy() method
 * in the config file
 *  
 * @author bran
 *
 */
public class TestInitDestroyMethod extends JacnTestCase {

	public static class InitDestroyer {
		String s = "";

		public void setup() {
			s = "inited";
		}
		
		public void clean() {
			s = "clean";
		}
		
		public String getS() {
			return s;
		}
	}
	
	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacn_config.class};
	}

	public void testInitDestroy() throws Exception {
//		System.out.println(ConvertUtil.jacn2Xml(Jacn_config.class));
//		
		final JacnApplicationContext c = getCtx();
		InitDestroyer des = (InitDestroyer) c.getBean("des");
		assertEquals("inited", des.getS());
		c.destroy();
		assertEquals("clean", des.getS());
	}
	
	/**
	 * the config file used for this test
	 * @author bran
	 *
	 */
	public static class Jacn_config extends AbstractJacnConfigFile {
		static InitDestroyer des;
		
		public void wire() throws Exception {
		}

//		@Override
		public void init() throws Exception {
			des.setup();
		}

//		@Override
		public void destroy() throws Exception {
			des.clean();
		}
		
	}
}
