/*
 * $Log$
 * Revision 1.1  2005/08/08 17:09:08  branaway
 * added support for adding post processing functional calls.
 * removed web dir since the web is now in another module called htdocs
 *
 * Revision 1.1  2005/08/03 12:42:50  branaway
 * added support for web application context integration: JacnWebApplicationContext
 *
 */
package bran.jacn.test;

import junit.framework.TestCase;
import bran.spring.jacn.JacnApplicationContext;

/**
 * test configuring a standalone application context using a mix of Jacn and xml
 * @author bran
 *
 */
public class TestJacnAppCtxMultiConfig extends TestCase {
	
	protected void setUp() throws Exception {
	}
	
	/**
	 * note the app context is loaded from an XML file and a Jacn file. 
	 */
	public void testMixXmlJacn() {
		Class[] jacns = new Class[] {ApplicationContext_bar.class};
		String[] xmls = new String[] {"/bran/jacn/test/ApplicationContext-Foo.xml"};
		JacnApplicationContext wac = new JacnApplicationContext(jacns, xmls, true);
		Foo f = (Foo) wac.getBean("foo");
		assertEquals(f.getBar().getMessage(), Foo.FOO);
	}

	/**
	 * test a pseudo url to an xml
	 *
	 */
	public void testMixClasspathXmlJacn() {
		Class[] jacns = new Class[] {ApplicationContext_bar.class};
		String[] xmls = new String[] {"classpath:/bran/jacn/test/ApplicationContext-Foo.xml"};
		JacnApplicationContext wac = new JacnApplicationContext(jacns, xmls, true);
		Foo f = (Foo) wac.getBean("foo");
		assertEquals(f.getBar().getMessage(), Foo.FOO);
	}
	
}
