/*
 * $Log$
 * Revision 1.4  2006/07/02 04:59:46  branaway
 * added testcase for init and destroy, and other trivial
 *
 * Revision 1.3  2005/08/22 17:59:11  branaway
 * use a simple way to verify the timing a object creation.
 *
 * Revision 1.2  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/19 19:21:31  branaway
 * added layInit. Added build.xml
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.springframework.transaction.interceptor.TransactionProxyFactoryBean;

import bran.jacn.test.TestEnableTx.Jacn_QuickTx;
import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */
public class TestLazyInit extends JacnTestCase {

	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacn_config.class};
	}

	public void testLazyInit() throws Exception {
		Document doc = ConvertUtil.jacn2JDom(Jacn_config.class);

		Element b = getTopBean(doc, "bar", Bar.class.getName());
		assertNotNull(b);
		Attribute a = b.getAttribute("lazy-init");
		assertNotNull(a);
		assertEquals("true", a.getValue());
		
		//		System.out.println(ConvertUtil.jacn2Xml(Jacn_config.class));
//		Foo foo = (Foo) getCtx().getBean("foo");
//		Thread.sleep(1);
//		long now = System.currentTimeMillis();
//		// bar is lazy inited
//		Bar bar = (Bar) getCtx().getBean("bar");
//		Thread.sleep(10);
//		// bar1 is eagerly inited
//		Bar bar1 = (Bar) getCtx().getBean("bar1");
//		assertTrue(bar.getInitTime() > bar1.getInitTime());
	}
	
	/**
	 * the config file used for this test
	 * @author bran
	 *
	 */
	public static class Jacn_config extends AbstractJacnConfigFile {
		static Foo foo;
		static Bar bar;
		static Bar bar1;
		
		public void wire() throws Exception {
			lazyInit(bar);
		}
	}
}
