/*
 * $Log$
 * Revision 1.1  2005/09/06 15:03:30  branaway
 * force cglib for enableTx if no interface is specified for the target object
 *
 * Revision 1.1  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import java.io.IOException;
import java.util.Properties;

import junit.framework.TestCase;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;
import bran.spring.jacn.JacnApplicationContext;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */	
public class TestLocalVars extends TestCase {


	public void testReuse() throws Exception {
		JacnApplicationContext ctx = new JacnApplicationContext(Jacnfig.class);
		Foo foo = (Foo) ctx.getBean("foo");
		Properties p = foo.getP1();
		assertEquals(p.get("p1"), "v1");
		assertNull(p.get("p2"));
		
//		p = foo.getP2();
//		assertEquals(p.get("p1"), "v1");
//		assertEquals(p.get("p2"), "v2");
		
		assertEquals("e", foo.getS1() );
		assertEquals("a", foo.getS2() );
		
		Bar b = foo.getBar();
		assertNotNull(b);
	}
	
	static class Foo {
		Properties p1, p2;

		String s1, s2;

		Bar bar;
		public Bar getBar() {
			return bar;
		}

		public void setBar(Bar bar) {
			this.bar = bar;
		}

		public String getS1() {
			return s1;
		}

		public void setS1(String s1) {
			this.s1 = s1;
		}

		public String getS2() {
			return s2;
		}

		public void setS2(String s2) {
			this.s2 = s2;
		}

		public Properties getP1() {
			return p1;
		}

		public void setP1(Properties p1) {
			this.p1 = p1;
		}

		public Properties getP2() {
			return p2;
		}

		public void setP2(Properties p2) {
			this.p2 = p2;
		}
	}
	static class Bar {
		String msg;

		public String getMsg() {
			return msg;
		}

		public void setMsg(String msg) {
			this.msg = msg;
		}
	}
	static class Jacnfig extends AbstractJacnConfigFile {
		static Foo foo;
		
		public void wire() throws Exception {
			
			{
				Properties vp = new Properties();
				vp.put("p1", "v1");
				foo.setP1(vp);
			}
			{
				Properties vp = new Properties(); 
				vp.put("p1", "v1");
				vp.put("p2", "v2");
				foo.setP2(vp);
			}
			
			Bar b1 = new Bar(); 
			String m = "b1";
			b1.setMsg(m);
			foo.setBar(b1);
			
			String s = "e";
			foo.setS1(s);
			
			s = "a";
			foo.setS2(s);
			
		}
	}
	
	// test local var refering a local field
	public void testLocalVarRefField() {
		JacnApplicationContext ctx = new JacnApplicationContext(Jacnfig.class);
		Foo foo = (Foo) ctx.getBean("foo");
		assertNotNull(foo.getBar());
	}
	
	static class Jacnfig2 extends AbstractJacnConfigFile {
		static Foo foo;
		Bar bar;
		
		public void wire() throws Exception {
			Bar b = bar;
			foo.setBar(b);
		}
		public static void main(String[] args) throws IOException {
			System.out.println(ConvertUtil.jacn2Xml(Jacnfig2.class));
		}
	}
}
