/*
 * $Log$
 * Revision 1.5  2006/07/02 04:59:46  branaway
 * added testcase for init and destroy, and other trivial
 *
 * Revision 1.4  2005/11/06 13:59:31  branaway
 * added better support for concurrent flows with transaction enabled backing beans
 *
 * Revision 1.3  2005/10/21 03:03:43  branaway
 * minor enhancement of SpringFaces
 *
 * Revision 1.2  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/19 19:21:31  branaway
 * added layInit. Added build.xml
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.JacnApplicationContext;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */
public class TestMap extends JacnTestCase {

	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacn_map.class};
	}

	public void testArrayRefElement() throws Exception {
		Bar bar = (Bar) getCtx().getBean("bar");
		assertEquals(bar.getMap().get("k1"), "v1");
		assertEquals(Foo.class, bar.getMap().get("k2").getClass());
		assertEquals(Foo.class, bar.getMap().get("k3").getClass());
//		assertEquals(Class.class, bar.getMap().get("k4").getClass() ); // Class object in map
		// this won't work!! the sutff being put in the map is a String rather than a Class object.
	}
	
	/**
	 * the config file used for this test
	 * @author bran
	 *
	 */
	public static class Jacn_map extends AbstractJacnConfigFile {
		static Bar bar;
		static Foo foo;
		public void wire() throws Exception {
			Class cl = String.class; // this won't work!! the sutff being put in the map is a String rather than a Class object.
			
			Map map = new HashMap(); {{ // "{" is used better indentation 
				map.put("k1", "v1");
				map.put("k2", foo); 
				{ // optional curly
					Foo foo1 = new Foo();
					map.put("k3", foo1);
				}
				map.put("k4", cl);
			}};
//			Map map = new HashMap() {{ // "{" is used better indentation 
//				put("k1", "v1");
//				put("k2", foo); 
//				{ // optional curly
//					Foo foo1 = new Foo();
//					put("k3", foo1);
//				}
//			}};
			
			bar.setMap(map);
		}
	}
	
	public void testContent() throws IOException {
//		JacnApplicationContext ac = new JacnApplicationContext(Jacn_map.class);
		String x = bran.spring.jacn.ConvertUtil.jacn2Xml(Jacn_map.class);
		System.out.println(x);
	}
}
