package bran.jacn.test;

import java.io.IOException;

import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.ConvertUtil;

public class TestMethodInvocationBean extends JacnTestCase {
	static final String DEC ="descoration"; // this is not bean def, better prefix it with _

	protected Class[] getConfigClasses() {
		return new Class[] {
				Jacn_methInvoke.class
		};
	}

	public void testMethCall() throws Exception {
		Foo f= (Foo) getCtx().getBean("foo");
		assertTrue(f.getClassName().startsWith(DEC));
		assertTrue(f.getClassName().endsWith(Foo.APPENDIX));
	}
	
	static class Jacn_methInvoke extends AbstractJacnConfigFile {
		static Foo foo;
		public void wire() throws Exception {
			foo.setClassName("anything");
			foo.processClassName(DEC);
			foo.finalTouchClassName();
		}

		/**
		 * this is more generic than the init-method attribute on beans since it can take args
		 */
//		public void invoke() throws Exception {
//		}
	}
	
	public static void main(String[] args) throws IOException {
		System.out.println(ConvertUtil.jacn2Xml(Jacn_methInvoke.class));
	}
}
