/*
 * $Log$
 * Revision 1.1  2005/08/22 14:44:34  branaway
 * now local vars in the wire() method of jacnfig is always treated as inline beans (common collections exluded).
 *
 * Revision 1.1  2005/08/04 17:58:03  branaway
 * works with AppFuse now
 *
 */
package bran.jacn.test;

import java.util.Properties;

import bran.spring.jacn.AbstractJacnConfigFile;

/**
 * test how to configure a PropertyPlaceholderConfigurer object in an app context
 * The trick here is the casting. See the comment in the config file. 
 * @author bran
 *
 */	
public class TestNameConflict extends JacnTestCase {

	/**
	 * load the config class
	 */
	protected Class[] getConfigClasses() {
		return new Class[] {Jacnfig.class};
	}

	public void testVarNaming() throws Exception {
		Foo foo = (Foo) getCtx().getBean("foo");
		
		assertEquals("e", foo.getS1() );
		assertEquals("a", foo.getS2() );
		
		Bar b = foo.getBar();
		assertEquals("b1", b.getMsg());
	}
	
	static class Foo {
		Properties p1, p2;

		String s1, s2;

		Bar bar;
		public Bar getBar() {
			return bar;
		}

		public void setBar(Bar bar) {
			this.bar = bar;
		}

		public String getS1() {
			return s1;
		}

		public void setS1(String s1) {
			this.s1 = s1;
		}

		public String getS2() {
			return s2;
		}

		public void setS2(String s2) {
			this.s2 = s2;
		}

		public Properties getP1() {
			return p1;
		}

		public void setP1(Properties p1) {
			this.p1 = p1;
		}

		public Properties getP2() {
			return p2;
		}

		public void setP2(Properties p2) {
			this.p2 = p2;
		}
	}
	static class Bar {
		String msg;

		public String getMsg() {
			return msg;
		}

		public void setMsg(String msg) {
			this.msg = msg;
		}
	}
	static class Jacnfig extends AbstractJacnConfigFile {
		static Foo foo;
		static Bar bar;
		
		public void wire() throws Exception {
			Bar bar = new Bar(); 
			String m = "b1";
			bar.setMsg(m);
			foo.setBar(bar);

			String s = "e";
			foo.setS1(s);
			
			s = "a";
			foo.setS2(s);
			
		}
	}
}
