package bran.jacn.test.mySpring;

import junit.framework.TestCase;

import org.springframework.core.io.Resource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

public class MultipleResourceLoaderTest extends TestCase {
	public void testLoadingClassPath() throws Exception {
		PathMatchingResourcePatternResolver resolver = new PathMatchingResourcePatternResolver();
		String pattern = getPattern();
		Resource[] rs = resolver.getResources(pattern);
		assertEquals(2, rs.length);
		for (int i = 0; i < rs.length; i++) {
			System.out.println(rs[i].getFilename());
		}
		
	}

	public void testLoadingClassPathFull() throws Exception {
		PathMatchingResourcePatternResolver resolver = new PathMatchingResourcePatternResolver();
		String pattern = rootPath() + "/*";
		Resource[] rs = resolver.getResources(pattern);
		assertTrue(rs.length >= 4);
		for (int i = 0; i < rs.length; i++) {
			System.out.println(rs[i].getFilename());
		}
		
	}
	
	/**
	 * 
	 * 
	 * @return ant style pattern: /bran/jacn/text/mySpring/*.txt
	 */
	private String getPattern() {
		String path = rootPath();
		String pattern = path + "/*.txt";
		return pattern;
	}

	private String rootPath() {
		String className = this.getClass().getName();
		String path = className.replace('.', '/');
		path = path.substring(0, path.lastIndexOf('/'));
		return path;
	}
}
