package bran.jacn.testinternal;

import junit.framework.TestCase;
import bran.spring.jacn.AbstractJacnConfigFile;
import bran.spring.jacn.JacnApplicationContext;
import bran.spring.jacn.WebScope;

public class TestJacnFace extends TestCase {
	static class AppBean {}
	static class SessionBean {}
	static class RequestBean {}
	static class FreeBean {}
	
	public void testScopeSetting() {
		JacnApplicationContext ctx = new JacnApplicationContext(JacnFaceConfig.class);
//		ctx.setConfigLocations(new String[] {
//				JacnFaceConfig.class.getName() + ".class"	
//		});
//		ctx.refresh();
		
		assertEquals(WebScope.APPLICATION_SCOPE, ctx.getScope("appBean"));
		assertEquals(WebScope.SESSION_SCOPE, ctx.getScope("sessionBean"));
		assertEquals(WebScope.REQUEST_SCOPE, ctx.getScope("requestBean"));
		assertEquals(WebScope.NONE_SCOPE, ctx.getScope("freeBean"));
	}
	static class JacnFaceConfig extends AbstractJacnConfigFile{
		static AppBean appBean;
		SessionBean sessionBean;
		RequestBean requestBean;
		FreeBean freeBean;
		
		public void wire() throws Exception {
			setWebScopeSession(new Object[]{sessionBean});
			setWebScopeRequest(new Object[]{requestBean});
		}
	}
}
